Ext.define('interaction.Support', {singleton:true, keys:{icons:{copy:'fa-copy', remove:'fa-times', 'delete':'fa-trash-alt', user:'fa-user', processRole:'fa-users', all:'fa-star'}, settings:{}}, getTasklistColumns:function(moduleId) {
  var columns = [{header:interaction.Support.getTranslation('task'), menuText:interaction.Support.getTranslation('task'), dataIndex:'name', width:30, renderer:function(v, p, r, rIdx, cIdx) {
    if (r.data.popup && r.data.popup == 'true') {
      return '\x3cspan class\x3d"' + interaction.Support.getBpcIconCls('arrow-alt-square-up') + '"\x3e\x3c/span\x3e';
    } else if (r.data.action === 'Info') {
      return '\x3cspan class\x3d"' + interaction.Support.getBpcIconCls('info-circle') + '"\x3e\x3c/span\x3e';
    } else {
      return '\x3cspan class\x3d"' + interaction.Support.getBpcIconCls('edit') + '"\x3e\x3c/span\x3e';
    }
  }}, {header:interaction.Support.getTranslation('taskName'), dataIndex:'name', gridItemId:'gridColumn', renderer:interaction.Support.getCellFormat, flex:1, sortable:true, filter:{type:'stringwithcheckbox', dataIndex:'name', emptyText:'Enter Filter Text...'}}, {header:interaction.Support.getTranslation('description'), dataIndex:'description', gridItemId:'gridColumn', renderer:interaction.Support.getCellFormat, flex:1, sortable:true, filter:{type:'stringwithcheckbox', dataIndex:'description', emptyText:'Enter Filter Text...'}}, 
  {header:interaction.Support.getTranslation('start'), dataIndex:'creation', xtype:'datecolumn', renderer:interaction.Support.getDateAndFormatCell, sortable:true, flex:1, filter:{type:'datetime'}}, {header:interaction.Support.getTranslation('expiration'), dataIndex:'expiration', xtype:'datecolumn', renderer:interaction.Support.getDateAndFormatCell, sortable:true, flex:1, filter:{type:'datetime'}}];
  var customFields = this.getCustomFields(moduleId) || {};
  if (customFields && Ext.isArray(customFields.Fields)) {
    var customFieldsCount = customFields.Fields.length;
    var selectedLanguage = BpcCommon.Api.getSetting('_core', 'language');
    for (var x = 0; x < customFieldsCount; x++) {
      if (customFields.Fields[x].name) {
        var header = selectedLanguage == 'en' ? customFields.Fields[x].en : customFields.Fields[x].de;
        columns.push({header:header, dataIndex:customFields.Fields[x].name + 'Field', renderer:interaction.Support.getCellFormat, sortable:true, gridItemId:'gridColumn', filter:{type:'stringwithcheckbox', emptyText:'Enter Filter Text...'}});
      }
    }
  }
  var moduleProperties = BpcCommon.Api.getSetting(moduleId, 'tasklist_configuration_params') || {};
  var actionItems = [];
  if (interaction.Support.validateBooleanProperty(moduleProperties.directLockAndUnlock, true)) {
    actionItems.push({iconCls:interaction.Support.getBpcIconCls('lock'), tooltip:interaction.Support.getTranslation('lockTask'), isActionDisabled:function(view, rowIndex, colIndex, item, record) {
      var grid = view.up('grid');
      return interaction.Support.validateBooleanProperty(grid.moduleProperties.lockedTasksEnabled, false) ? false : record && record.get('locked') && record.get('locked') !== grid.user;
    }, handler:function(grid, rowIndex, colIndex) {
      var rowSelected = grid.store.getAt(rowIndex);
      var taskId = rowSelected.get('formName');
      var locked = rowSelected.get('locked');
      var storeView = grid.store.storeView;
      var url = '';
      var columnLength = grid.ownerGrid.columnManager.columns.length - 1;
      if (locked) {
        url = storeView.baseUrl + 'task/unlockAction' + '?instanceId\x3d' + storeView.moduleId + '\x26lang\x3d' + storeView.lang + '\x26id\x3d' + taskId;
        grid.ownerGrid.columnManager.columns[columnLength].items[0].iconCls = interaction.Support.getBpcIconCls('lock');
        grid.ownerGrid.columnManager.columns[columnLength].items[0].tooltip = interaction.Support.getTranslation('lockTask');
      } else {
        url = storeView.baseUrl + 'task/lockAction' + '?instanceId\x3d' + storeView.moduleId + '\x26lang\x3d' + storeView.lang + '\x26id\x3d' + taskId;
        grid.ownerGrid.columnManager.columns[columnLength].items[0].iconCls = interaction.Support.getBpcIconCls('unlock');
        grid.ownerGrid.columnManager.columns[columnLength].items[0].tooltip = interaction.Support.getTranslation('unlockTask');
      }
      interaction.Support.callAjaxAndRefresh(url);
    }});
  }
  if (interaction.Support.validateBooleanProperty(moduleProperties.directToDelegate, true)) {
    actionItems.push({iconCls:interaction.Support.getBpcIconCls('share-square'), tooltip:interaction.Support.getTranslation('delegateTask'), isActionDisabled:function(view, rowIndex, colIndex, item, record) {
      var grid = view.up('grid');
      return record && (record.get('locked') && record.get('locked') !== grid.user) || !record.get('delegateRuleSetId') || record.get('restrictDelegationToRole') && !BpcCommon.Api.hasUserRole(record.get('restrictDelegationToRole'));
    }, handler:function(grid, rowIndex, colIndex) {
      var rowSelected = grid.store.getAt(rowIndex);
      var taskId = rowSelected.get('formName');
      var storeView = grid.store.storeView;
      var delegateUrl = storeView.baseUrl + 'task/delegation' + '?instanceId\x3d' + storeView.moduleId + '\x26lang\x3d' + storeView.lang + '\x26id\x3d' + taskId;
      var delegateSubmitUrl = storeView.baseUrl + 'task/delegation/' + taskId + '?instanceId\x3d' + storeView.moduleId + '\x26lang\x3d' + storeView.lang;
      interaction.Support.createAndShowWindow(delegateUrl, delegateSubmitUrl);
    }});
  }
  if (interaction.Support.validateBooleanProperty(moduleProperties.directDelegateToAll, false)) {
    actionItems.push({iconCls:interaction.Support.getBpcIconCls('share-all'), tooltip:interaction.Support.getTranslation('delegateAll'), isActionDisabled:function(view, rowIndex, colIndex, item, record) {
      var grid = view.up('grid');
      return record && (record.get('locked') && record.get('locked') !== grid.user) || !record.get('delegateRuleSetId') || record.get('restrictDelegationToRole') && !BpcCommon.Api.hasUserRole(record.get('restrictDelegationToRole'));
    }, handler:function(grid, rowIndex, colIndex) {
      var rowSelected = grid.store.getAt(rowIndex);
      var taskId = rowSelected.get('formName');
      var storeView = grid.store.storeView;
      var delegateAllUrl = storeView.baseUrl + 'task/delegation' + '?instanceId\x3d' + storeView.moduleId + '\x26lang\x3d' + storeView.lang + '\x26id\x3d' + taskId;
      interaction.Support.callAjaxAndRefresh(delegateAllUrl);
    }});
  }
  var showDeleteActionValue = BpcCommon.Api.getSetting(moduleId, 'showDeleteAction');
  var hasRole = BpcCommon.Api.hasUserRole('bpcadmin');
  showDeleteActionValue = Ext.isDefined(showDeleteActionValue) ? showDeleteActionValue : false;
  if (showDeleteActionValue && hasRole) {
    actionItems.push({iconCls:interaction.Support.getBpcIconCls(interaction.Support.keys.icons["delete"]), tooltip:interaction.Support.getTranslation('DELETE'), handler:function(grid, rowIndex, colIndex) {
      var record = grid.store.getAt(rowIndex);
      var taskId = record.get('formName');
      var locked = record.get('locked');
      var loggedInUser = grid.up('grid').user;
      interaction.Support.confirmDialog(interaction.Support.getTranslation('DELETE_TASK'), locked != null && loggedInUser !== locked ? interaction.Support.getTranslation('DELETE_LOCKED_TASK_DESC') + " ' " + locked + " '. " + interaction.Support.getTranslation('DELETE_TASK_PERMISSION') : interaction.Support.getTranslation('DELETE_TASK_DESC')).then(function(yes) {
        if (yes) {
          interaction.Support.doRequest(grid.store.storeView.baseUrl + 'task/' + taskId + '?instanceId\x3d' + grid.store.storeView.moduleId, 'DELETE').then(function(success) {
            BpcCommon.Api.showNotification(interaction.Support.getTranslation('DELETE_SUCCESS'));
          }, function(error) {
            BpcCommon.Api.showNotification('DELETE_ERROR');
          });
        }
      });
    }});
  }
  columns.push({xtype:'actioncolumn', header:interaction.Support.getTranslation('taskActions'), menuText:interaction.Support.getTranslation('taskActions'), renderer:function(v, p, r, rIdx, cIdx) {
    var directLockUnlock = interaction.Support.validateBooleanProperty(p.record.store.config.storeView.config.moduleProperties.directLockAndUnlock, true);
    if (directLockUnlock) {
      if (r.data.locked) {
        p.column.items[0].iconCls = interaction.Support.getBpcIconCls('unlock');
        p.column.items[0].tooltip = interaction.Support.getTranslation('unlockTask');
      } else {
        p.column.items[0].iconCls = interaction.Support.getBpcIconCls('lock');
        p.column.items[0].tooltip = interaction.Support.getTranslation('lockTask');
      }
    }
  }, dataIndex:'name', width:actionItems.length * 40, items:actionItems});
  return columns;
}, confirmDialog:function(title, message) {
  return new Ext.Promise(function(resolve, reject) {
    Ext.Msg.show({title:title, message:message, buttons:Ext.Msg.YESNO, icon:Ext.Msg.QUESTION, fn:function(btn) {
      if (btn === 'yes') {
        resolve(true);
      } else if (btn === 'no') {
        resolve(false);
      } else {
        resolve(false);
      }
    }});
  });
}, getDateAndFormatCell:function(v, p, r, rIdx, cIdx) {
  return interaction.Support.getCellFormat(Ext.Date.format(v, 'd.m.Y H:i:s'), p, r, rIdx, cIdx);
}, getCellFormat:function(v, p, r, rIdx, cIdx) {
  if (!!v) {
    var moduleProperties = p.record.store.storeView.config.moduleProperties;
    var lockedtask = interaction.Support.validateBooleanProperty(moduleProperties.lockedTasksEnabled, false);
    var timeoutWarningInPercent = interaction.Support.getIntegerProperty(moduleProperties.timeoutWarningInPercent, 80);
    var s, color = '';
    color = '';
    if (((new Date()).getTime() - r.data.creation.getTime()) * 100 / (r.data.expiration.getTime() - r.data.creation.getTime()) > timeoutWarningInPercent && r.data.creation.getTime() !== r.data.expiration.getTime()) {
      color = 'color:firebrick;';
    }
    var locked = false;
    if (!r.data.locked || r.data.locked.length == 0) {
      s = Ext.String.format('\x3cspan style\x3d"{0}', color);
    } else if (r.data.locked == p.record.store.storeView.user) {
      s = Ext.String.format('\x3cspan style\x3d"{0}font-weight: bold;', color);
    } else {
      s = Ext.String.format('\x3cspan style\x3d"color:#cccccc;', r.data.locked);
      if (cIdx == 1) {
        v += ' (' + r.data.locked + ')';
      }
      locked = true;
    }
    s = s + 'display:block;width:100%;"\x3e' + v + '\x3c/span\x3e';
    return s;
  }
}, getBpcIconCls:function(fontAwesomeName) {
  return BpcCommon.util.Icons.getBpcIconCls(fontAwesomeName);
}, getTranslation:function(key) {
  var starter = 'INTERACTION_';
  key = !Ext.String.startsWith(key, starter) ? starter + key : key;
  return BpcCommon.Api.getTranslation(key);
}, getBaseUrlForModuleId:function(moduleId) {
  var delegateRequestsToOwnBackend = BpcCommon.Api.getSetting(moduleId, 'delegate_requests_to_own_backend_enable');
  return delegateRequestsToOwnBackend ? '/cxf/bpc-interaction/tasks/' : BpcCommon.Api.getBackendUrl(BpcCommon.Api.getSetting(moduleId, 'proxy_Id')) + '/ibis/rest/';
}, getCustomFields:function(moduleId) {
  try {
    var properties = BpcCommon.Api.getSetting(moduleId, 'tasklist_configuration_params');
    var isStaticEntries = interaction.Support.validateBooleanProperty(properties.staticEntries, false);
    if (isStaticEntries == true) {
      return BpcCommon.Api.getSetting(moduleId, 'taskList_custom_field_params');
    }
  } catch (e) {
    Ext.log({msg:'getCustomFields() exception handled', level:'info'});
  }
  return null;
}, submitViaExtJs:function(method, url, data, headers, sync) {
  method = method || 'POST';
  data = data || {};
  headers = headers || {'Content-Type':'multipart/form-data'};
  sync = sync || false;
  var requestConfig = Ext.apply({}, {method:method, url:url, headers:headers, rawData:data, async:!sync});
  return this.sendRequest(requestConfig);
}, loadData:function(url) {
  return this.doRequest(url, 'POST');
}, doRequest:function(url, method) {
  method = method || 'GET';
  return this.sendRequest({url:url, method:method});
}, sendRequest:function(options) {
  Ext.getBody().mask('Loading...').dom.style.zIndex = '99999';
  Ext.Ajax.on('requestcomplete', function() {
    Ext.getBody().unmask();
  });
  return Ext.Ajax.request(options);
}, callAjaxAndRefresh:function(url) {
  interaction.Support.loadData(url).then(function(successResponse) {
    Ext.log('Ajax request:success');
    this.tasksGrid.store.load();
  }.bind(this), function(response) {
    Ext.log('Ajax request:failure ');
    var window = Ext.ComponentQuery ? Ext.ComponentQuery.query('#autoload-win')[0] : Ext.ComponentMgr.get('autoload-win');
    window.fireUnlock = false;
    window.close();
    if (response.status === 423) {
      Ext.Msg.alert(interaction.Support.getTranslation('warning'), interaction.Support.getTranslation('taskLocked'));
    }
  }.bind(this));
}, createAndShowWindow:function(delegateUrl, delegateSubmitUrl) {
  var win = Ext.create({xtype:'interactionWindow', itemId:'delegateWindow', title:interaction.Support.getTranslation('delegate_header'), height:document.body.clientHeight * 0.5, width:document.body.clientWidth * 0.3, closeAction:'destroy', items:[Ext.create({xtype:'interactionDelegateFormWindow', delegateUrl:delegateUrl, delegateSubmitUrl:delegateSubmitUrl})]});
  win.show();
  return win;
}, getMasterViewPosition:function(position) {
  position = position || 'west';
  if (!Ext.isString(position)) {
    position = String(position);
  }
  return ['west', 'east', 'south', 'north', 'center'].indexOf(position.toLowerCase()) !== -1 ? position : 'west';
}, getTaskViewPosition:function(position) {
  position = position || 'west';
  if (!Ext.isString(position)) {
    position = String(position);
  }
  return ['west', 'east', 'south', 'north', 'center'].indexOf(position.toLowerCase()) !== -1 ? position : 'east';
}, getIntegerProperty:function(intProperty, defaultValue) {
  if (intProperty) {
    if (!isNaN(intProperty)) {
      if (parseInt(intProperty) > 0) {
        return parseInt(intProperty);
      }
    }
  }
  return defaultValue;
}, validateBooleanProperty:function(boolProperty, defaultValue) {
  if (typeof boolProperty === 'boolean') {
    return boolProperty;
  } else if (boolProperty) {
    if (boolProperty === 'true') {
      return true;
    } else if (boolProperty === 'false') {
      return false;
    }
  }
  return defaultValue;
}, createEmptyTaskDetailPanel:function() {
  return Ext.create('Ext.panel.Panel', {itemId:'defaultTaskDetailPanel', title:interaction.Support.getTranslation('TASKDETAIL_DEFAULTTITLE'), bodyPadding:10, html:interaction.Support.getTranslation('TASKDETAIL_DEFAULTTEXT')});
}, saveSize:function(container) {
  var config_params = BpcCommon.Api.getSetting(container.moduleId, 'tasklist_configuration_params') || {};
  var masterDetailSize = config_params.masterDetailView ? container.down('#masterDetailContainer').getSize() : undefined;
  var taskDetailSize = config_params.taskDetailView ? container.down('#taskDetailContainer').getSize() : undefined;
  var taskGridSize = container.down('#taskGridContainer').getSize();
  var containerSettings = {'masterDetailView':interaction.Support.validateBooleanProperty(config_params.masterDetailView, true), 'taskDetailView':interaction.Support.validateBooleanProperty(config_params.taskDetailView, false), 'masterViewPosition':config_params.masterViewPosition, 'masterDetailSize':masterDetailSize, 'taskDetailPosition':config_params.taskDetailPosition, 'taskDetailSize':taskDetailSize, 'taskGridSize':taskGridSize};
  if (taskDetailSize !== container.getSize()) {
    localStorage.setItem('interactionContainerConfig-' + container.moduleId, JSON.stringify(containerSettings));
  }
}, copyToClipBoard:function(text, extCmp) {
  function copyToClp(stringWithNewLines) {
    try {
      var myFluffyTextarea = document.createElement('textarea');
      myFluffyTextarea.innerHTML = stringWithNewLines;
      var parentElement = document.getElementById(extCmp.getId());
      parentElement.appendChild(myFluffyTextarea);
      myFluffyTextarea.select();
      document.execCommand('copy');
      parentElement.removeChild(myFluffyTextarea);
      return true;
    } catch (e) {
      return false;
    }
  }
  return copyToClp(text);
}, destroyMainPanel:function(panelName) {
  var query = 'panel[id\x3d' + panelName + ']';
  var panels = Ext.ComponentQuery.query(query);
  if (panels.length > 0) {
    Ext.each(panels, function(panel) {
      panel.destroy();
    });
  }
}});
Ext.define('interaction.view.widget.Task', {extend:'Ext.panel.Panel', alias:'widget.interactionTaskWidget', mixins:['BpcCommon.mixin.Widget'], statics:{WIDGET_NAME:'Process Interaction Task Widget', WIDGET_DESCRIPTION:BpcCommon.Api.getTranslation('INTERACTION_WIDGET_DESCRIPTION'), WIDGET_ICON_CLS:'x-fal fa-tasks'}, widgetConfigSettingMap:{moduleId:{settingType:'moduleInstance'}, visibleColumns:{settingType:'text'}, role:{settingType:'text'}}, config:{widgetConfiguration:{visibleColumns:'name, creation', 
role:null}}, layout:'card', activeItem:0, title:false, moduleId:undefined, widgetId:undefined, initComponent:function() {
  try {
    this.initWidgetSettings();
  } catch (e) {
  }
  this.callParent(arguments);
  this.initWidget();
  this.settingPanel = this.add({xtype:'bpcSettingPanel', settings:this.settingStore, buttons:[{text:'OK', handler:this.configureWidget.bind(this)}, {text:'Standardwerte', handler:this.prepareWidgetConfiguration.bind(this, true)}]});
}, initWidget:function() {
  var $jscomp$this = this;
  var widgetCmp = {xtype:'container', html:'\x3cbr/\x3e Die ModuleId wurde dem Widget nicht zugewiesen oder existiert nicht.'};
  if (this.moduleId) {
    var dbComp = this.up('dbMain');
    var matchingWidgets = null;
    if (dbComp && dbComp.isComponent) {
      matchingWidgets = dbComp.query('bpcInteractionMain').filter(function(a) {
        return a.moduleId === $jscomp$this.moduleId && a.isVisible() === true;
      });
    }
    if (matchingWidgets != null && matchingWidgets.length > 0) {
      widgetCmp.html = BpcCommon.Api.getTranslation('INTERACTION_DASHBOARD_MULTI_INSTANCE');
      this.doNotLoad = true;
    } else {
      widgetCmp = Ext.create(Ext.apply({}, {xtype:'bpcInteractionMain'}, {moduleId:this.moduleId, header:false, baseUrl:interaction.Support.getBaseUrlForModuleId(this.moduleId), bpcWidget:true}));
      var widgetConfiguration = this.getWidgetConfiguration();
      var visibleColumns = widgetConfiguration.visibleColumns ? widgetConfiguration.visibleColumns.split(',').map(function(i) {
        return i.trim();
      }) : [];
      var useLimitedColumns = visibleColumns.length > 0;
      if (widgetConfiguration.role) {
        widgetCmp.unitsGrid.setAndLoad(widgetConfiguration.role);
      }
      widgetCmp.unitsGrid.hide();
      widgetCmp.tasksGrid.getColumns().map(function(col, i) {
        var visible = useLimitedColumns ? col && col.dataIndex && visibleColumns.indexOf(col.dataIndex) !== -1 : true;
        col.setVisible(visible);
      });
      widgetCmp.taskDetailPanel.hide();
      var items = widgetCmp.tasksGrid.toolbarReference.query('[addedAfterInit]');
      items.map(function(c, i) {
        if (i > 8) {
          c.hide();
        }
      });
      widgetCmp.tasksGrid.store.on('load', this.onStoreLoad.bind(this));
      this.widgetWrapper = this.up('dbWidgetWrapper');
    }
  }
  this.wrapper = this.add(widgetCmp);
}, onStoreLoad:function(s, recs, success) {
  var counter = success ? s.getTotalCount() : 0;
  if (this.widgetWrapper) {
    this.widgetWrapper.setTitle('Aufgaben ' + '( ' + counter + ' )');
  }
}, refreshWidget:function() {
  var $jscomp$this = this;
  if (this.wrapper && this.doNotLoad === undefined) {
    this.wrapper.setLoading(interaction.Support.getTranslation('INTERACTION_TASKLIST_REFRESH_LOAD_MSG'));
    this.wrapper.loadData().then(function(arrayOfSuccess) {
      $jscomp$this.wrapper.setLoading(false);
    });
  }
}, configureWidget:function() {
  this.getLayout().setActiveItem(this.settingPanel.isVisible(true) ? this.wrapper : this.settingPanel);
}});
Ext.define('interaction.BpcInterface', {extend:'BpcCommon.BpcInterface', requires:['interaction.view.widget.Task'], config:{moduleConfigurationComponents:['interactionConfig'], baseModuleView:null, mainView:null, widgets:['interaction.view.widget.Task']}});
Ext.define('interaction.components.BaseWindow', {extend:'Ext.window.Window', alias:'widget.interactionWindow', maximizable:true, modal:true, autoScroll:true, layout:'fit'});
Ext.define('interaction.components.HtmlPanel', {extend:'Ext.panel.Panel', alias:'widget.interactionHtmlPanel', update:function(htmlOrData, loadScripts, callback, scriptScope) {
  var panel = this;
  var me = this, isData = me.tpl && !Ext.isString(htmlOrData), container = me.ownerFocusableContainer, sizeModel, doLayout, el;
  Ext.getBody().mask('Loading...').dom.style.zIndex = '99999';
  if (isData) {
    me.data = htmlOrData && htmlOrData.isEntity ? htmlOrData.getData(true) : htmlOrData;
  } else {
    me.html = Ext.isObject(htmlOrData) ? Ext.DomHelper.markup(htmlOrData) : htmlOrData;
  }
  if (me.rendered) {
    sizeModel = me.getSizeModel();
    doLayout = sizeModel.width.shrinkWrap || sizeModel.height.shrinkWrap;
    if (me.isContainer) {
      el = me.layout.getRenderTarget();
      doLayout = doLayout || me.items.items.length > 0;
    } else {
      el = me.getTargetEl();
    }
    if (isData) {
      me.tpl[me.tplWriteMode](el, me.data || {});
    } else {
      var forceValidScript = BpcCommon.Api.getSetting(this.moduleId, 'forceValidScriptInjection');
      if (forceValidScript) {
        var scriptTagRe = /(?:<script([^>]*)?>)((\n|\r|.)*?)(?:<\/script>)/ig, replaceScriptTagRe = /(?:<script.*?>)((\n|\r|.)*?)(?:<\/script>)/ig, srcRe = /\ssrc=(['"])(.*?)\1/i, DOC = document, typeRe = /\stype=(['"])(.*?)\1/i;
        el.setHtml = function(html, loadScripts, callback, scope) {
          var me = this, id, dom, interval;
          if (!me.dom) {
            return me;
          }
          html = html || '';
          dom = me.dom;
          if (loadScripts !== true) {
            if (Ext.isIE) {
              while (dom.firstChild) {
                dom.removeChild(dom.firstChild);
              }
            }
            dom.innerHTML = html;
            Ext.callback(callback, me);
            return me;
          }
          id = Ext.id();
          html += '\x3cspan id\x3d"' + id + '" role\x3d"presentation"\x3e\x3c/span\x3e';
          interval = Ext.interval(function() {
            var hd, match, attrs, srcMatch, typeMatch, el, s;
            if (!(el = DOC.getElementById(id))) {
              return false;
            }
            Ext.uninterval(interval);
            Ext.removeNode(el);
            hd = Ext.getHead().dom;
            while (match = scriptTagRe.exec(html)) {
              attrs = match[1];
              srcMatch = attrs ? attrs.match(srcRe) : false;
              if (srcMatch && srcMatch[2]) {
                s = DOC.createElement('script');
                s.src = srcMatch[2];
                typeMatch = attrs.match(typeRe);
                if (typeMatch && typeMatch[2]) {
                  s.type = typeMatch[2];
                }
                hd.appendChild(s);
              } else {
                if (match[2] && match[2].length > 0) {
                  if (scope) {
                    var save = void 0;
                    try {
                      save = match[2];
                      Ext.functionFactory(match[2]).call(scope);
                    } catch (e) {
                      panel.handleScriptError(e, save);
                    }
                  } else {
                    Ext.globalEval(match[2]);
                  }
                }
              }
            }
            Ext.callback(callback, scope || me);
          }, 20);
          dom.innerHTML = html.replace(replaceScriptTagRe, '');
          Ext.Ajax.on('requestcomplete', function() {
            Ext.getBody().unmask();
          });
          Ext.Ajax.on('requestexception', function() {
            Ext.getBody().unmask();
          });
          return me;
        }.bind(el);
      }
      el.setHtml(me.html, loadScripts, callback, scriptScope || me);
    }
    if (doLayout) {
      me.updateLayout();
    }
    if (container && !container.onFocusableChildUpdate.$nullFn) {
      container.onFocusableChildUpdate(me);
    }
  }
}, scriptErrorOccurred:false, handleScriptError:function(e, scriptText) {
  var $jscomp$this = this;
  scriptText = scriptText === void 0 ? '' : scriptText;
  if (!this.scriptErrorOccurred) {
    this.scriptErrorOccurred = true;
    Ext.defer(function() {
      if ($jscomp$this) {
        $jscomp$this.removeAll();
        var p = $jscomp$this.add({xtype:'panel', flex:1, tbar:[{xtype:'button', iconCls:interaction.Support.getBpcIconCls('fa-exclamation-triangle'), text:interaction.Support.getTranslation('ERROR_INJECT_SCRIPT'), tooltip:interaction.Support.getTranslation('ERROR_COPY_PAYLOAD'), handler:function(b) {
          if (interaction.Support.copyToClipBoard(scriptText, $jscomp$this)) {
            BpcCommon.Api.showNotification('TEXT_COPIED');
          }
        }}, {xtype:'textfield', fieldLabel:interaction.Support.getTranslation('ERROR_TYPE'), value:e.name || '-1', readOnly:true, flex:1, margin:'0 0 0 5'}, {xtype:'textfield', fieldLabel:interaction.Support.getTranslation('ERROR_MESSAGE'), value:e.message || '-1', readOnly:true, flex:1, margin:'0 0 0 5'}], layout:'fit', items:[{xtype:'textarea', value:scriptText, readOnly:true, grow:true}]});
        p.setWidth('100%');
        p.setHeight('100%');
      }
    }, 500);
  }
}});
Ext.define('interaction.model.Task', {extend:'Ext.data.Model', proxy:{type:'ajax', reader:'xml'}, fields:[{name:'name', mapping:'Name'}, {name:'description', mapping:'Description'}, {name:'creation', type:'date', mapping:'@creation', convertOnSet:false, dateFormat:'d.m.Y H:i:s', convert:function(v, record) {
  return Ext.Date.parseDate(parseInt(v / 1000), 'U');
}}, {name:'expiration', type:'date', mapping:'@expiration', convertOnSet:false, dateFormat:'d.m.Y H:i:s', convert:function(v, record) {
  return Ext.Date.parseDate(parseInt(v / 1000), 'U');
}}, {name:'unitName', mapping:'Unit/@name'}, {name:'unitType', mapping:'Unit/@type'}, {name:'locked', mapping:'@locked'}, {name:'formName', mapping:'@id'}, {name:'action', mapping:'@action'}, {name:'link', mapping:'@link'}, {name:'restrictDelegationToRole', mapping:'@restrictDelegationToRole'}, {name:'delegateRuleSetId', mapping:'@delegateRuleSetId'}, {name:'popup', mapping:'@popup'}]});
Ext.define('interaction.model.Unit', {extend:'Ext.data.Model', fields:[{name:'type', mapping:'@type'}, {name:'name', mapping:'@name', type:'string'}, {name:'tasks', mapping:'@tasks'}]});
Ext.define('interaction.plugin.BpcPluginMixin', {getValueFromPluginConfiguration:function(key, fromContext) {
  if (this.pluginConfiguration && Ext.isObject(this.pluginConfiguration)) {
    if (!fromContext) {
      if (this.pluginConfiguration.configuration && Ext.isObject(this.pluginConfiguration.configuration)) {
        var pluginConfig = this.pluginConfiguration.configuration;
        if (key in pluginConfig && pluginConfig[key]) {
          return pluginConfig[key];
        }
      }
    } else if (fromContext) {
      if (this.pluginConfiguration.context && Ext.isObject(this.pluginConfiguration.context)) {
        var ctx = this.pluginConfiguration.context;
        if (key in ctx && ctx[key]) {
          return ctx[key];
        }
      }
    }
  }
  return undefined;
}});
Ext.define('interaction.plugin.detailWindow.Main', {extend:'Ext.panel.Panel', alias:'widget.interactionTaskListPlugin', mixins:['interaction.plugin.BpcPluginMixin'], layout:'fit', padding:'5 5 5 5', idValue:undefined, legacy:false, flexTableParams:undefined, baseTitle:'', initComponent:function() {
  this.iconCls = BpcCommon.util.Icons.getBpcIconCls(this.getValueFromPluginConfiguration('iconCls') || 'fa-tasks');
  this.moduleId = this.getValueFromPluginConfiguration('moduleId') || undefined;
  this.title = this.getValueFromPluginConfiguration('title') || 'Meine Aufgaben';
  this.filterField = this.getValueFromPluginConfiguration('filterField') || 'processid';
  var monitorRecord = this.getValueFromPluginConfiguration('record', true);
  var instanceId = this.getValueFromPluginConfiguration('instanceId', true);
  this.processIdFilterEnabled = this.getValueFromPluginConfiguration('processIdFilterEnabled', true);
  var processIdValue = monitorRecord.get(BpcCommon.Api.getSetting(instanceId, 'column_id'));
  var interactionCmp = Ext.apply({}, {xtype:'bpcInteractionMain'}, {moduleId:this.moduleId, header:false, baseUrl:interaction.Support.getBaseUrlForModuleId(this.moduleId), bpcPlugin:true, bpcWidget:true});
  if (this.processIdFilterEnabled && processIdValue) {
    interactionCmp.filters = [{filterField:this.filterField + 'Field', filterValue:processIdValue}];
  }
  this.interactionCmp = Ext.create(interactionCmp);
  this.items = [this.interactionCmp];
  this.callParent(arguments);
}});
Ext.define('interaction.plugin.detailWindow.Wrapper', {extend:'BpcCommon.plugin.Interface', inheritableStatics:{NAME:'Interaction Plugin', COMPONENT_XTYPE:'interactionTaskListPlugin', PLUGIN_ID:'interaction-plugin-task-list'}});
Ext.define('interaction.services.AjaxScript', {extend:'Ext.Base', singleton:true, reinitAjaxDOM:function(ns, currentPage) {
  var parser = new DOMParser();
  currentPage.ajaxValidation.DOM = parser.parseFromString('\x3c?xml version\x3d"1.0" encoding\x3d"UTF-8"?\x3e\x3cresult/\x3e', 'text/xml');
  currentPage.ajaxValidation.portletNS = ns;
  currentPage.ajaxValidation.form = document.getElementsByTagName('form').item(ns + 'formIS');
}, doSubmitWithAjaxValidation:function() {
  if (dataIS.key == '13') {
    dataIS.key = null;
    return false;
  }
  interaction.services.AjaxScript.getValidationIS(this, false, 'Submission');
  return false;
}, getValidationIS:function(validationButton, errorNodesMustBeVisible, caller) {
  return false;
}, setSubmitAjax:function(node) {
  if (interaction.services.Script.hasAttribute(node, 'preSubmitCode')) {
    node.onclick = interaction.services.AjaxScript.doSubmitWithAjaxValidation;
  }
}, doAjaxSubmitWithAjaxValidation:function() {
  interaction.services.AjaxScript.getValidationIS(this, false, 'ajaxSubmission');
  return false;
}, addToAjaxErrorNodes:function(node, errorMsg, currentPage) {
  if (!node) {
    return;
  }
  if (!currentPage.ajaxValidation.DOM) {
    interaction.services.AjaxScript.reinitAjaxDOM(interaction.services.Script.getPortletNsIS(node));
  }
  var htmls = currentPage.ajaxValidation.DOM.getElementsByTagName('html');
  for (var c = 0; c < htmls.length; c++) {
    if (htmls[c].firstChild.nodeValue == errorMsg) {
      var nodes = htmls[c].getElementsByTagName('errornode');
      for (var i$0 = 0; i$0 < nodes.length; i$0++) {
        if (interaction.services.Script.getIdWithoutNsIS(node) == nodes[i$0].firstChild.nodeValue) {
          return;
        }
      }
      var errorNode2Add = currentPage.ajaxValidation.DOM.createElement('errornode');
      errorNode2Add.appendChild(currentPage.ajaxValidation.DOM.createTextNode(interaction.services.Script.getIdWithoutNsIS(node)));
      htmls[c].getElementsByTagName('errornodes')[0].appendChild(errorNode2Add);
      return;
    }
  }
  var result = currentPage.ajaxValidation.DOM.getElementsByTagName('result')[0];
  var html = currentPage.ajaxValidation.DOM.createElement('html');
  var errorNodesID = currentPage.ajaxValidation.DOM.createAttribute('id');
  errorNodesID.nodeValue = 'patternMatched_' + htmls.length;
  var errorNodes = currentPage.ajaxValidation.DOM.createElement('errornodes');
  errorNodes.setAttributeNode(errorNodesID);
  var errorNode = currentPage.ajaxValidation.DOM.createElement('errornode');
  result.appendChild(html);
  html.appendChild(currentPage.ajaxValidation.DOM.createTextNode(errorMsg));
  html.appendChild(errorNodes);
  errorNodes.appendChild(errorNode);
  errorNode.appendChild(currentPage.ajaxValidation.DOM.createTextNode(interaction.services.Script.getIdWithoutNs(node)));
}, showALLErrorNodes:function(errorDOM, currentPage) {
  interaction.services.AjaxScript.removeALLErrorNodes(currentPage);
  var errorNodes = Array.from(errorDOM.getElementsByTagName('errornodes'));
  for (var c = 0; c < errorNodes.length; c++) {
    interaction.services.AjaxScript.showErrorNodes(errorNodes[c], false, currentPage);
  }
  currentPage.ajaxValidation.allErrorNodesAreBlocked = true;
}, showErrorNodes:function(errorNodes, setFocus, currentPage) {
  if (errorNodes) {
    for (var c = 0; c < errorNodes.childNodes.length; c++) {
      if (errorNodes.childNodes[c].firstChild) {
        var errorInput = document.getElementById(currentPage.ajaxValidation.portletNS + errorNodes.childNodes[c].firstChild.nodeValue);
        if (errorInput) {
          var isErrorNode = errorInput.getAttribute('isErrorNode');
          if (isErrorNode == undefined || typeof isErrorNode == 'string' && isErrorNode != 'true') {
            errorInput.setAttribute('isErrorNode', 'true');
            errorInput.setAttribute('originalBackgroundColorIS', interaction.services.Script.createStyle(errorInput, 'background-color'));
            errorInput.setAttribute('originalBackgroundImageIS', interaction.services.Script.createStyle(errorInput, 'background-image'));
          }
          interaction.services.Script.setStyleIS(errorInput, 'background', 'none');
          interaction.services.Script.setStyleIS(errorInput, 'backgroundColor', currentPage.dataIS[currentPage.ajaxValidation.portletNS + 'warningColor']);
        }
      }
    }
  }
}, removeALLErrorNodes:function(currentPage) {
  currentPage.ajaxValidation.currentSelectedErrorMessage = undefined;
  var controls = Array.from(currentPage.ajaxValidation.form);
  for (i = 0; i < controls.length; i++) {
    var isErrorNode = controls[i].getAttribute('isErrorNode');
    if (typeof isErrorNode == 'string' && isErrorNode == 'true') {
      var type = controls[i].getAttribute('type');
      if (type == 'submit' || type == 'button') {
        return;
      }
      controls[i].setAttribute('isErrorNode', 'false');
      var restoreStye = '';
      restoreStye += controls[i].getAttribute('originalBackgroundColorIS') + ' ';
      restoreStye += controls[i].getAttribute('originalBackgroundImageIS') + ' ';
      interaction.services.Script.setStyleIS(controls[i], 'background', restoreStye);
    }
  }
  currentPage.ajaxValidation.allErrorNodesAreBlocked = false;
}, getErrorHeading:function(heading, errorCount) {
  if (errorCount < 2) {
    var tmp = '';
    var inScript = false;
    for (var c = 0; c < heading.length; c++) {
      if (heading.charAt(c) == '{') {
        inScript = true;
      }
      if (heading.charAt(c) == '}') {
        inScript = false;
      }
      if (!inScript) {
        tmp += heading.charAt(c);
      }
    }
    heading = tmp;
  }
  heading = interaction.services.Script.stringReplaceAll(heading, '{errorCount}', errorCount < 2 ? '' : String(errorCount));
  heading = interaction.services.Script.stringReplaceAll(heading, '{', '');
  heading = interaction.services.Script.stringReplaceAll(heading, '}', '');
  return heading;
}, getErrorMessageCount:function(currentPage) {
  var count = 0;
  var htmls = currentPage.ajaxValidation.DOM.getElementsByTagName('html');
  for (var c = 0; c < htmls.length; c++) {
    if (htmls[c].firstChild.nodeValue.length > 0) {
      count++;
    }
  }
  return count;
}});
Ext.define('interaction.services.Script', {extend:'Ext.Base', singleton:'true', activeSubmits:{}, initIS:function(params, dataIS) {
  try {
    dataIS = dataIS || {};
    if (dataIS['ajaxLoad']) {
      try {
        if (ajaxValidation.form !== null) {
          ajaxValidation.form.style['cursor'] = 'default';
        }
      } catch (e) {
      }
      dataIS['AjaxValidationIsCurrentlyRunning'] = false;
    }
  } catch (e$1) {
    Ext.log('Exception in InitIS:' + e$1.message);
  }
  window.dataIS['ajaxLoad'] = false;
}, ajaxCallForSubmit:function(ns, url, moduleId) {
  var me = this;
  var holdingCmp = Ext.ComponentQuery ? Ext.ComponentQuery.query('#autoload-win')[0] : Ext.ComponentMgr.get('autoload-win');
  if (!holdingCmp && Ext.ComponentQuery && moduleId) {
    var panels = Ext.ComponentQuery.query('#interactionTaskFormPanel' + moduleId);
    holdingCmp = panels.length ? panels[0] : undefined;
  }
  if (me.activeSubmits[moduleId]) {
    console.warn('block submit, there is a pending submit!');
    return;
  } else {
    me.activeSubmits[moduleId] = true;
  }
  var isTaskDetailPanel = holdingCmp.isTaskDetailPanel ? true : false;
  interaction.Support.submitViaExtJs('POST', url, new FormData(document.getElementById(ns + 'formIS'))).then(function(response) {
    var messageKey = [200, 204].indexOf(response.status) !== -1 ? 'TASK_SUBMIT_SUCCESS_MSG' : 'TASK_SUBMIT_ERROR_MSG';
    BpcCommon.Api.showNotification(interaction.Support.getTranslation(messageKey));
    me.activeSubmits[moduleId] = false;
    if (response.status === 200 && response.responseText !== '') {
      if (holdingCmp.xtype === 'interactionTaskFormPanel' && isTaskDetailPanel) {
        holdingCmp.tasksGrid.openTaskWindow(response.responseText, holdingCmp.taskName, true);
      } else {
        var tabPanel = holdingCmp.up('tabPanel');
        if (tabPanel) {
          tabPanel.remove(holdingCmp);
        }
        holdingCmp.tasksGrid.openTaskWindow(response.responseText);
        holdingCmp.close();
      }
    } else {
      if (isTaskDetailPanel) {
        var taskDetailPanel = Ext.ComponentQuery.query('#taskDetailPanel' + moduleId)[0];
        taskDetailPanel.up().up().down('#taskGridContainer').setHidden(false);
        taskDetailPanel.up().up().down('#masterDetailContainer').setHidden(false);
        if (taskDetailPanel.previousSize) {
          taskDetailPanel.up().setSize(taskDetailPanel.previousSize);
        }
        taskDetailPanel.items.remove(holdingCmp);
        var interactionTaskFormPanel = Ext.ComponentQuery.query('#interactionTaskFormPanel' + moduleId)[0];
        interactionTaskFormPanel.destroy();
        taskDetailPanel.items.add(interaction.Support.createEmptyTaskDetailPanel());
        taskDetailPanel.updateLayout();
      }
      var panelName = 'i_' + holdingCmp.formName.replaceAll('-', '') + '_' + 'MainPanel';
      interaction.Support.destroyMainPanel(panelName);
      holdingCmp.close();
    }
  }, function(error) {
    var messageKey = 'TASK_SUBMIT_ERROR_MSG';
    BpcCommon.Api.showNotification(interaction.Support.getTranslation(messageKey));
    me.activeSubmits[moduleId] = false;
  });
  return false;
}, checkForExtForSubmit:function(event, ns, url, formData, portalInfo, moduleId) {
  if (event) {
    event.preventDefault();
  }
  if (interaction.services.Script.doSubmitIS(ns)) {
    dataIS[ns + 'done'] = false;
    interaction.services.Script.ajaxCallForSubmit(ns, url, moduleId);
  }
  return false;
}, checkForExt:function(event, ns, url, formData, portalInfo) {
  var delimiter = '\x26';
  document[ns].action += delimiter + 'isExt\x3dtrue';
  return interaction.services.Script.doSubmitIS(ns);
}, doSubmitIS:function(namespace, currentPage) {
  var ns = namespace ? namespace : '';
  var result = interaction.services.Script.patternMatchIS(ns, currentPage);
  if (result) {
    result = interaction.services.Script.doServerSideValidation(ns, currentPage);
  }
  if (currentPage.dataIS.key == '13') {
    currentPage.dataIS.key = null;
    return false;
  }
  if (result) {
    if (currentPage.dataIS[ns + 'done']) {
      return false;
    }
    if (result) {
      currentPage.dataIS[ns + 'done'] = true;
    }
  }
  return result;
}, getFormDataIS:function(namespace) {
  var ns = arguments.length > 0 ? arguments[0] : '';
  return Ext.dom.Element.serializeForm(interaction.services.Script.componentIS(ns + 'formIS'));
}, setFormDataIS:function(html) {
  var ns = arguments.length > 1 ? arguments[1] : '';
  console.log('The function setFormDataIS is not implemented. Please contact Virtimo for suport');
}, setFormUrlIS:function(url, callback) {
  new Ext.Ajax.request({url:url, method:'get', success:callback});
}, removeComponentIS:function(componentOrId, descendantLevel) {
  var ns = arguments.length > 2 ? arguments[2] : '';
  var c = interaction.services.Script.componentIS(componentOrId, ns);
  var parent = c;
  if (descendantLevel > 0) {
    for (var i$2 = 0; i$2 <= descendantLevel && parent.parentNode != null; i$2++) {
      parent = parent.parentNode;
    }
  }
  parent.parentNode.removeChild(parent);
  return c;
}, componentIS:function(componentOrId) {
  if (!interaction.services.Script.isComponentIS(componentOrId)) {
    var ns = arguments.length > 1 ? arguments[1] : '';
    return document.getElementById(ns + componentOrId);
  } else {
    return componentOrId;
  }
}, isVisibleIS:function(componentOrId) {
  var ns = arguments.length > 2 ? arguments[2] : '';
  var c = interaction.services.Script.componentIS(componentOrId, ns);
  while (c != null) {
    if (c.style != null && c.style.display == 'none') {
      return false;
    }
    c = c.parentNode;
  }
  return true;
}, isComponentIS:function(node) {
  if (node == null || node == undefined || node.nodeType == undefined) {
    return false;
  } else {
    return node.nodeType == 1;
  }
}, patternMatchIS:function(namespace, currentPage) {
  var ns = namespace ? namespace : '';
  var local = currentPage.dataIS[ns + 'vForms'];
  var result = true;
  var language = 'de';
  interaction.services.AjaxScript.reinitAjaxDOM(ns, currentPage);
  if (currentPage.dataIS[ns + 'validate']) {
    for (var loop = 0; loop < local.length; loop++) {
      var element = interaction.services.Script.componentIS(local[loop].id, ns);
      if (local[loop].pattern != null && element) {
        var regExp = new RegExp(local[loop].pattern);
        if (interaction.services.Script.isVisibleIS(element) && !element.disabled && !regExp.test(interaction.services.Script.getDataIS(element.id))) {
          result = false;
          interaction.services.AjaxScript.addToAjaxErrorNodes(element, local[loop].errMsg, currentPage);
          language = currentPage.dataIS[interaction.services.Script.getPortletNsIS(element) + 'lang'];
        }
      }
    }
    try {
      interaction.services.AjaxScript.showALLErrorNodes(currentPage.ajaxValidation.DOM, currentPage);
      if (arguments.length < 3) {
        var errorMessageCount = interaction.services.AjaxScript.getErrorMessageCount(currentPage);
        if (errorMessageCount == 0) {
          return result;
        }
        var headline;
        if (language == 'de') {
          headline = interaction.services.AjaxScript.getErrorHeading('{errorCount} Fehler bei der Formularpr\x26uuml;fung', errorMessageCount);
        } else {
          headline = interaction.services.AjaxScript.getErrorHeading('{errorCount} error{s} at form validation', errorMessageCount);
        }
        var errors = currentPage.ajaxValidation.DOM.getElementsByTagName('html');
        if (window.tooltip === undefined) {
          window.tooltip = Ext.create('window.tooltip');
        } else {
          tooltip.hide();
        }
        var content = interaction.services.Script.createErrorContent(errors);
        if (currentPage.dataIS.submitter) {
          currentPage.ajaxValidation.submitter = currentPage.dataIS.submitter;
        }
        tooltip.setTitle(headline);
        tooltip.setData(content);
        tooltip.target = document.getElementsByTagName('form').formIS;
        tooltip.anchor = 'top';
        tooltip.show();
      }
    } catch (e) {
    }
  }
  return result;
}, doServerSideValidation:function(namespace, currentPage) {
  if (window.tooltip === undefined) {
    window.tooltip = Ext.create('window.tooltip');
  } else {
    tooltip.hide();
  }
  var isValidationSuccess = true;
  var moduleId = Ext.ComponentQuery.query('bpcInteractionTasksGrid')[0].moduleId;
  var lang = BPC.getApplication().getController('BPC.controller.ConfigurationController').localConfiguration._core.language;
  var helpUrl = interaction.Support.getBaseUrlForModuleId(moduleId) + 'task/help?instanceId\x3d' + moduleId + '\x26lang\x3d' + lang + '\x26ajaxType\x3dvalidation\x26ajaxMode\x3dajaxSubmission\x26form\x3d' + currentPage.form;
  var response = interaction.Support.submitViaExtJs('POST', helpUrl, interaction.services.Script.getFormDataIS(namespace), '', true);
  if (response.status === 200 && response.responseText && response.responseText !== 'ERROR - ValidatePredicates are NULL.' && response.responseText !== 'ERROR - taskModule properties NULL.') {
    var parser = new DOMParser();
    var xmlDoc = parser.parseFromString(response.responseText, 'text/xml');
    var errors = xmlDoc.getElementsByTagName('html');
    if (errors.length === 0) {
      return isValidationSuccess;
    }
    isValidationSuccess = false;
    interaction.services.AjaxScript.showALLErrorNodes(xmlDoc, currentPage);
    var content = interaction.services.Script.createErrorContent(errors);
    tooltip.setData(content);
    if (xmlDoc.getElementsByTagName('heading') && xmlDoc.getElementsByTagName('heading')[0] && xmlDoc.getElementsByTagName('heading')[0].childNodes) {
      tooltip.setTitle(xmlDoc.getElementsByTagName('heading')[0].childNodes[0].nodeValue);
    }
    tooltip.target = document.getElementsByTagName('form')[namespace + 'formIS'];
    tooltip.anchor = 'top';
    tooltip.show();
  }
  return isValidationSuccess;
}, setSubmitPropertyIS:function(target, validate, namespace, currentPage) {
  var ns = namespace ? namespace : '';
  interaction.services.Script.componentIS('hiddenSubmitIS', ns).value = target;
  currentPage.dataIS[ns + 'validate'] = !(validate == 'false');
}, hasAttribute:function(node, attributeName) {
  if (node == null) {
    return false;
  }
  try {
    var test = node.getAttribute(attributeName);
    if (test != null) {
      return true;
    }
  } catch (e) {
    return false;
  }
  return false;
}, setDataIS:function(componentOrId, data) {
  var ns = arguments.length > 2 ? arguments[2] : '';
  var c = interaction.services.Script.componentIS(componentOrId, ns);
  if (c != null) {
    if (c.type == 'checkbox' || c.type == 'radio') {
      c.checked = data;
    } else {
      c.value = data;
    }
  }
}, getDataIS:function(componentOrId) {
  var ns = arguments.length > 1 ? arguments[1] : '';
  var c = interaction.services.Script.componentIS(componentOrId, ns);
  if (c != null) {
    if (c.type == 'checkbox' || c.type == 'radio') {
      return c.checked;
    } else {
      return c.value;
    }
  }
  return null;
}, getFormIS:function(node) {
  if (node == undefined || node == null || node.nodeType != 1) {
    return null;
  } else if (node.nodeName.toUpperCase() == 'FORM') {
    return node;
  } else {
    return interaction.services.Script.getFormIS(node.parentNode);
  }
}, getPortletNsIS:function(node) {
  return interaction.services.Script.getFormIS(node) ? interaction.services.Script.getFormIS(node).getAttribute('name') : null;
}, getFormIdentifierIS:function(node, currentPage) {
  return currentPage.dataIS[interaction.services.Script.getPortletNsIS(node) + 'form'];
}, stringReplaceAll:function(sourceStr, findStr, repStr) {
  return sourceStr.replace(new RegExp(findStr, 'g'), repStr);
}, addPatternMatchIS:function(pattern, id, errorText, namespace, currentPage) {
  var ns = namespace ? namespace : '';
  var o = new Object();
  o.pattern = pattern;
  o.id = id;
  o.errMsg = errorText;
  if (window.dataIS) {
    window.dataIS[ns + 'vForms'].push(o);
  } else if (currentPage.dataIS) {
    currentPage.updateDataISArray(ns + 'vForms', o);
  }
}, showHelpToolTip:function(ns, node, currentPage) {
  if (!currentPage.dataIS[ns + 'ajaxHelp']) {
    return;
  }
  if (window.tooltip === undefined) {
    window.tooltip = Ext.create('window.tooltip');
  } else {
    tooltip.hide();
  }
  var moduleId = Ext.ComponentQuery.query('bpcInteractionTasksGrid')[0].moduleId;
  var lang = BPC.getApplication().getController('BPC.controller.ConfigurationController').localConfiguration._core.language;
  var helpUrl = interaction.Support.getBaseUrlForModuleId(moduleId) + 'task/help?instanceId\x3d' + moduleId + '\x26lang\x3d' + lang + '\x26ajaxType\x3dhelp\x26ajaxMode\x3dExperte\x26ajaxNode\x3d' + node.id.replace(interaction.services.Script.getPortletNsIS(node), '') + '\x26form\x3d' + interaction.services.Script.getFormIdentifierIS(node, currentPage);
  Ext.getBody().mask('Loading...').dom.style.zIndex = '99999';
  Ext.Ajax.request({url:helpUrl, method:'POST', scope:this, contentType:'text/xml', params:interaction.services.Script.stringReplaceAll(Ext.dom.Element.serializeForm(interaction.services.Script.getFormIS(node)), interaction.services.Script.getPortletNsIS(node), ''), asynchronous:true, success:function(response) {
    var parser = new DOMParser();
    var xmlDoc = parser.parseFromString(response.responseText, 'text/xml');
    tooltip.setData(xmlDoc.getElementsByTagName('html')[0].childNodes[0].nodeValue);
    tooltip.setTitle(xmlDoc.getElementsByTagName('heading')[0].childNodes[0].nodeValue);
    tooltip.target = document.getElementById(node.id);
    tooltip.anchor = 'left', tooltip.show();
  }, failure:function(response) {
    console.error('Server side exception occured while showing help tooltip');
  }});
}, getIdWithoutNsIS:function(element) {
  if (!interaction.services.Script.hasAttribute(element, 'id')) {
    return '';
  }
  var id = element.getAttribute('id');
  if (id.indexOf(interaction.services.Script.getPortletNsIS(element)) != -1) {
    return id.substring(interaction.services.Script.getPortletNsIS(element).length);
  } else {
    return id;
  }
}, getContextPathIS:function(node, currentPage) {
  return currentPage.dataIS[interaction.services.Support.getPortletNsIS(node) + 'contextPath'];
}, setStyleIS:function(componentOrId, styleName, value) {
  var ns = arguments.length > 3 ? arguments[3] : '';
  var c = interaction.services.Script.componentIS(componentOrId, ns);
  if (c != null) {
    c.style[styleName] = value;
  }
}, createStyle:function(element, style) {
  element = element;
  style = style == 'float' ? 'cssFloat' : interaction.services.Script.camelize(style);
  var value = element.style[style];
  if (!value || value == 'auto') {
    var css = document.defaultView.getComputedStyle(element, null);
    value = css ? css[style] : null;
  }
  if (style == 'opacity') {
    return value ? parseFloat(value) : 1;
  }
  return value == 'auto' ? null : value;
}, camelize:function(style) {
  return style.replace(/-+(.)?/g, function(match, chr) {
    return chr ? chr.toUpperCase() : '';
  });
}, createErrorContent:function(errors) {
  var content = '';
  for (var c = 0; c < errors.length; c++) {
    content += errors[c].childNodes[0].nodeValue + '\x3c/br\x3e';
  }
  return content;
}, ajaxSubmitIS:function(trigger, url, groupOrGroupId, jump, currentPage) {
  var ns = arguments.length > 4 ? arguments[4] : '';
  var portletDiv = interaction.services.Script.componentIS('bodyIS', ns);
  var form = interaction.services.Script.componentIS('formIS', ns);
  var data = (groupOrGroupId != null ? 'ISAjaxGroup\x3d' + groupOrGroupId + '\x26' : '') + (jump != null ? 'ISJump\x3d' + jump + '\x26' : '') + Form.serialize(form);
  if (groupOrGroupId != null) {
    portletDiv = interaction.services.Script.componentIS(groupOrGroupId, ns);
  }
  var pointerButton = interaction.services.Script.getStyleIS(trigger, 'cursor');
  var pointerBody = interaction.services.Script.getStyleIS(document.body, 'cursor');
  try {
    interaction.services.Script.setStyleIS(trigger, 'cursor', 'wait');
    interaction.services.Script.setStyleIS(document.body, 'cursor', 'wait');
    Ext.getBody().mask('Loading...').dom.style.zIndex = '99999';
    Ext.Ajax.Request({url:url, method:'post', parameters:data, onFailure:function(req) {
      interaction.services.Script.setStyleIS(trigger, 'cursor', pointerButton);
      interaction.services.Script.setStyleIS(document.body, 'cursor', pointerBody);
    }, onComplete:function(req) {
      if (req.responseText.length > 0) {
        var p = portletDiv.parentNode;
        interaction.services.Script.setHtmlIS(p, req.responseText, ns);
        currentPage.dataIS['ajaxLoad'] = true;
        try {
          var srcs = interaction.services.Script.extractScriptSrcsIS(req.responseText);
          for (var j = 0; j < srcs.length; j++) {
            if (srcs[j].length > 0) {
              interaction.services.Script.addScriptIS(srcs[j], new function() {
              }());
            }
          }
        } catch (e) {
          alert(e);
        }
        currentPage.dataIS[ns + 'done'] = false;
        interaction.services.Script.setStyleIS(trigger, 'cursor', pointerButton);
        interaction.services.Script.setStyleIS(document.body, 'cursor', pointerBody);
        if (typeof currentPage.dataIS[ns + 'ajaxSubmitCallback'] != 'undefined') {
          currentPage.dataIS[ns + 'ajaxSubmitCallback']();
        }
      } else {
        interaction.services.Script.setStyleIS(trigger, 'cursor', pointerButton);
        interaction.services.Script.setStyleIS(document.body, 'cursor', pointerBody);
        window.location.reload();
      }
      if (groupOrGroupId != null) {
        interaction.services.Script.initIS(ns);
      }
      interaction.services.Script.disableSubmitButtons(ns, false);
    }});
  } catch (e) {
    interaction.services.Script.disableSubmitButtons(ns, false);
    interaction.services.Script.setStyleIS(trigger, 'cursor', pointerButton);
    interaction.services.Script.setStyleIS(document.body, 'cursor', pointerBody);
  }
}, getIdWithoutNs:function(element) {
  if (!interaction.services.Script.hasAttribute(element, 'id')) {
    return '';
  }
  var id = element.getAttribute('id');
  if (id.indexOf(interaction.services.Script.getPortletNsIS(element)) != -1) {
    return id.substring(interaction.services.Script.getPortletNsIS(element).length);
  } else {
    return id;
  }
}, disableSubmitButtons:function(namespace, setFlag) {
  if (setFlag) {
    els = document[namespace].querySelectorAll('[type\x3dsubmit]:enabled,[type\x3dbutton]:enabled');
  }
  for (var i$3 = 0; i$3 < els.length; i$3++) {
    els[i$3].disabled = setFlag;
  }
  if (!setFlag) {
    els = [];
  }
}, getStyleIS:function(componentOrId, styleName) {
  var ns = arguments.length > 2 ? arguments[2] : '';
  var c = interaction.services.Script.componentIS(componentOrId, ns);
  if (c != null) {
    return c.style[styleName];
  } else {
    return null;
  }
}, extractScriptsIS:function(string) {
  var matchAll = new RegExp('(?:\x3cscript.*?\x3e)((\n|\r|.)*?)(?:\x3c/script\x3e)', 'img');
  var matchOne = new RegExp('(?:\x3cscript.*?\x3e)((\n|\r|.)*?)(?:\x3c/script\x3e)', 'im');
  return (string.match(matchAll) || []).map(function(scriptTag) {
    return (scriptTag.match(matchOne) || ['', ''])[1];
  });
}, extractScriptSrcsIS:function(string) {
  var matchAll = new RegExp('(?:\x3cscript.*?src\x3d["\'](.*?)["\'].*?\x3e).*?(?:\x3c/script\x3e)', 'img');
  var matchOne = new RegExp('(?:\x3cscript.*?src\x3d["\'](.*?)["\'].*?\x3e).*?(?:\x3c/script\x3e)', 'im');
  return (string.match(matchAll) || []).map(function(scriptTag) {
    return (scriptTag.match(matchOne) || ['', ''])[1];
  });
}, addScriptIS:function(url, cache, callback) {
  Ext.loader.loadScript({url:url, onLoad:callback});
}, showMessageIS:function(title, message) {
  var text = title ? title : '';
  if (message) {
    text = text + '\n' + message;
  }
  BpcCommon.Api.showNotification({text:text, popUp:true});
}, centerInWindow:function(componentOrId) {
  var c = interaction.services.Script.componentIS(componentOrId);
  var s = c.style;
  s.position = 'fixed';
  if (window.innerWidth) {
    s.left = (window.innerWidth - c.offsetWidth) / 2;
    s.top = (window.innerHeight - c.offsetHeight) / 2;
  } else {
    s.left = (document.body.offsetWidth - c.offsetWidth) / 2;
    s.top = (document.body.offsetHeight - c.offsetHeight) / 2;
  }
}, addCssIS:function(file) {
  var link = document.createElement('link');
  link.setAttribute('rel', 'stylesheet');
  link.setAttribute('type', 'text/css');
  link.setAttribute('href', file);
  document.getElementsByTagName('head').item(0).appendChild(link);
}, backButtonOverrideIS:function() {
  interaction.services.Script.backButtonOverrideBodyIS();
}, backButtonOverrideBodyIS:function() {
  try {
    history.forward();
  } catch (e) {
  }
  interaction.services.Script.setTimeout('backButtonOverrideBodyIS()', 500);
}, backIS:function(namespace, currentPage) {
  var ns = namespace ? namespace : '';
  currentPage.dataIS[ns + 'panels'].pop();
  self[ns + 'showPanelIS'](currentPage.dataIS[ns + 'panels'].pop());
}, getIS:function(panelName) {
  var ns = arguments.length > 1 ? arguments[1] : '';
  self[ns + 'showPanelIS'](panelName);
}, addParamToUrl:function(url, delimiter, keyValuePair, portalInfo, nspace) {
  var url = url + delimiter;
  for (var property in keyValuePair) {
    if (keyValuePair.hasOwnProperty(property)) {
      url += property + '\x3d' + keyValuePair[property] + '\x26';
    }
  }
  return url.substring(0, url.length - 1);
}, changeFormActionToUploadIS:function(newAction, namespace, currentPage) {
  var ns = namespace ? namespace : '';
  currentPage.dataIS[ns + 'validate'] = false;
  interaction.services.Script.componentIS('formIS', ns).action = newAction;
  interaction.services.Script.componentIS('formIS', ns).enctype = 'multipart/form-data';
  interaction.services.Script.componentIS('formIS', ns).encoding = 'multipart/form-data';
}, getPositionIS:function(componentOrId) {
  var ns = arguments.length > 1 ? arguments[1] : '';
  var obj = interaction.services.Script.componentIS(componentOrId, ns);
  var pos = {left:0, top:0};
  if (typeof obj.offsetLeft != 'undefined') {
    while (obj) {
      pos.left += obj.offsetLeft;
      pos.top += obj.offsetTop;
      obj = obj.offsetParent;
    }
  } else {
    pos.left = obj.left;
    pos.top = obj.top;
  }
  return pos;
}, getHtmlIS:function(componentOrId) {
  var ns = arguments.length > 1 ? arguments[1] : '';
  var c = interaction.services.Script.componentIS(componentOrId, ns);
  return c.innerHTML;
}, setHtmlIS:function(componentOrId, html) {
  var ns = arguments.length > 2 ? arguments[2] : '';
  var c = interaction.services.Script.componentIS(componentOrId, ns);
  c.innerHTML = html;
}, onCancel:function() {
  var moduleId = Ext.ComponentQuery.query('bpcInteractionTasksGrid')[0].moduleId;
  var holdingCmp = Ext.ComponentQuery ? Ext.ComponentQuery.query('#autoload-win')[0] : Ext.ComponentMgr.get('autoload-win');
  if (!holdingCmp && Ext.ComponentQuery && moduleId) {
    var panels = Ext.ComponentQuery.query('#interactionTaskFormPanel' + moduleId);
    holdingCmp = panels.length ? panels[0] : undefined;
  }
  holdingCmp.close();
}, onKeyDown:function(event) {
  if (event.keyCode === 13) {
    if (event.srcElement.nodeName !== 'TEXTAREA') {
      event.preventDefault();
      return false;
    }
  }
}});
Ext.define('interaction.view.tasklist.grids.Tasks', {extend:'Ext.grid.Panel', alias:['widget.bpcInteractionTasksGrid'], requires:['interaction.model.Task'], controller:'tasks', border:false, title:interaction.Support.getTranslation('taskGridTitle'), header:true, viewConfig:{deferEmptyText:false, emptyText:interaction.Support.getTranslation('no_tasks')}, plugins:'gridfilters', initComponent:function() {
  this.listeners = {filterchange:this.onFilterChange.bind(this), celldblclick:this.onCellDblclick.bind(this)};
  var pageRows = interaction.Support.getIntegerProperty(this.moduleProperties.pageRows, 10);
  var fields = [];
  var me = this;
  var customFieldsJson = this.customFields;
  if (customFieldsJson && Ext.isArray(customFieldsJson.Fields)) {
    var customFieldCount = customFieldsJson.Fields.length;
    for (var x = 0; x < customFieldCount; x++) {
      if (customFieldsJson.Fields[x].name) {
        fields.push({name:customFieldsJson.Fields[x].name + 'Field', type:'auto', mapping:'Field[@name\x3d' + customFieldsJson.Fields[x].name + ']'});
      }
    }
  }
  var taskModel = Ext.define(null, {extend:'interaction.model.Task', fields:fields});
  this.initURL = this.baseUrl + 'task/tasks' + '?instanceId\x3d' + this.moduleId + '\x26lang\x3d' + this.lang;
  var proxyUrl = this.initURL;
  var userType = localStorage.getItem('unit-filter-' + this.moduleId);
  var roleType = localStorage.getItem('unit-filter-type-' + this.moduleId);
  if (this.stateful && Ext.isDefined(userType) && Ext.isDefined(roleType)) {
    this.root.unitsGrid.roleSelection = userType;
    this.root.unitsGrid.typeSelection = roleType;
    proxyUrl = this.initURL + '\x26filterField\x3dUnit/@name\x26filterValue\x3d' + userType + '\x26filterComparison\x3deq\x26comparisonType\x3d' + '\x26filterField\x3dUnit/@type\x26filterValue\x3d' + roleType + '\x26filterComparison\x3deq';
  }
  Ext.Ajax.on('requestexception', function(conn, response) {
    me.ownerGrid.view.loadMask.hide();
    me.root.unitsGrid.view.loadMask.hide();
    if (response.status === 503) {
      me.setEmptyText(interaction.Support.getTranslation('service_unavailable_desc'));
      BpcCommon.Api.showNotification(interaction.Support.getTranslation('SERVICE_UNAVAILABLE_MSG'));
    } else if (response.status === 401) {
      me.setEmptyText(interaction.Support.getTranslation('UNAUTHORIZED'));
      BpcCommon.Api.showNotification(interaction.Support.getTranslation('UNAUTHORIZED'));
    } else if (response.status === 417) {
      me.setEmptyText(interaction.Support.getTranslation('EXPECTATION_FAILED'));
      BpcCommon.Api.showNotification(interaction.Support.getTranslation('EXPECTATION_FAILED'));
    } else if (response.status === 400) {
      me.setEmptyText(interaction.Support.getTranslation('BACKEND_ERROR'));
      BpcCommon.Api.showNotification(interaction.Support.getTranslation('BACKEND_ERROR'));
    }
  }, me);
  this.store = Ext.create('Ext.data.Store', {storeId:'taskliststore', storeView:this, autoLoad:true, start:0, pageSize:pageRows, remoteSort:true, remoteGroup:true, remoteFilter:true, sorters:[{direction:'DESC', property:'creation'}], model:taskModel, listeners:{load:function(store, records, success, eOpts) {
    if (success) {
      me.onStoreLoad(this);
      me.setEmptyText(interaction.Support.getTranslation('no_tasks'));
    }
  }}, proxy:{type:'ajax', url:proxyUrl, reader:{type:'xml', rootProperty:'Tasklist', record:'Task', idProperty:'@id', totalProperty:'@total', successProperty:'@success'}, simpleSortMode:true}});
  var pagingBar = Ext.create('Ext.toolbar.Paging', {stateId:'tlextpagingBarExtJsIS', store:this.store, displayInfo:true, emptyMsg:'-', forceLayout:true, scrollable:'true', stateful:this.stateful, stateEvents:['change'], getState:function() {
    return {currentPage:this.store.currentPage};
  }, applyState:function(state) {
    this.store.currentPage = state.currentPage;
  }, cls:'toolbar', listeners:{add:function(tb, cmp) {
    cmp.addedAfterInit = true;
  }}});
  pagingBar.add([{xtype:'tbspacer', width:15}, {xtype:'checkboxfield', fieldLabel:interaction.Support.getTranslation('activateHelp'), itemId:'helpCheckbox', value:this.activateHelpLocal, listeners:{change:function(checkbox, newVal, oldVal, event) {
    localStorage.setItem('activateHelp-' + this.up().up().moduleId, newVal);
  }}}, {xtype:'tbspacer', width:15}]);
  if (interaction.Support.validateBooleanProperty(this.moduleProperties.adHocStarter, false)) {
    this.adhocCombo = Ext.create({xtype:'combo', fieldLabel:interaction.Support.getTranslation('adhoc'), labelWidth:110, queryMode:'local', matchFieldWidth:false, emptyText:interaction.Support.getTranslation('emptyTaskSelection'), displayField:'name', valueField:'value', editable:false, store:Ext.create('Ext.data.Store', {data:[]})});
    Ext.Ajax.request({url:this.baseUrl + 'task/adhoc' + '?instanceId\x3d' + this.moduleId + '\x26lang\x3d' + this.lang, success:function(response, options) {
      var hasAdhocTask = false;
      if (response.responseXML) {
        var adhocFields = Ext.DomQuery.select('Module', response.responseXML);
        if (adhocFields.length > 0) {
          hasAdhocTask = true;
          for (var i = 0; i < adhocFields.length; i++) {
            this.adhocCombo.store.add({value:adhocFields[i].attributes[2].nodeValue, name:adhocFields[i].attributes[0].nodeValue});
          }
        }
      }
      if (!hasAdhocTask) {
        this.adhocCombo.setEmptyText(interaction.Support.getTranslation('noAdhocTaskForSelection'));
        this.toolbarReference.getComponent('adhocCheckIcon').hide();
      }
    }.bind(this)});
    pagingBar.add(this.adhocCombo);
    pagingBar.add({iconCls:interaction.Support.getBpcIconCls('check'), itemId:'adhocCheckIcon', scope:this, handler:function(b) {
      var selectedValue = this.adhocCombo.getValue();
      if (selectedValue && selectedValue != '') {
        var taskDetailView = interaction.Support.validateBooleanProperty(this.moduleProperties.taskDetailView, false);
        var adhocSubmitUrl = this.baseUrl + 'task/submitAdhoc' + '?instanceId\x3d' + this.moduleId + '\x26lang\x3d' + this.lang + '\x26adHocId\x3d' + selectedValue;
        interaction.Support.loadData(adhocSubmitUrl).then(function(successResponse) {
          if (successResponse.getResponseHeader('com.inubit.infotask') === 'true') {
            this.getController().openInfoTaskWindow(this, this.controller, successResponse.responseText, taskDetailView);
          } else if (successResponse.getResponseHeader('com.inubit.processID')) {
            Ext.Msg.alert(interaction.Support.getTranslation('info'), BpcCommon.Api.getTranslation({key:'INTERACTION_ADHOC_TASK_DELAY_MSG', data:{processID:successResponse.getResponseHeader('com.inubit.processID')}}));
          } else {
            this.openTaskWindow(successResponse.responseText, null, interaction.Support.validateBooleanProperty(this.moduleProperties.taskDetailView, false));
          }
          this.store.load();
        }.bind(this), function(response) {
        }.bind(this));
      }
    }});
  }
  this.toolbarReference = pagingBar;
  var pagingBarAtTop = interaction.Support.validateBooleanProperty(this.moduleProperties.pagingBarAtTop, false);
  this[pagingBarAtTop === false ? 'bbar' : 'tbar'] = this.toolbarReference;
  this.callParent(arguments);
}, onStoreLoad:function(store) {
  var totalCount = store.getTotalCount();
  var currentPage = store.currentPage;
  var pageSize = store.pageSize;
  if (currentPage > 1) {
    var prevpageCount = (currentPage - 1) * pageSize;
    if (totalCount <= prevpageCount) {
      store.currentPage = store.currentPage - 1;
      store.load();
    }
  }
}, resetGridFilters:function() {
  this.getPlugin('gridfilters').clearFilters();
}, onFilterChange:function() {
  this.reloadTasklistAfterFilterModification();
}, onCellDblclick:function(grid, td, cellIndex, record, tr, rowIndex, event) {
  var lockedUser = record.get('locked');
  var taskId = record.get('formName');
  var main = this.up().up();
  if (main) {
    var taskDetailView = main.bpcWidget ? false : interaction.Support.validateBooleanProperty(this.moduleProperties.taskDetailView, false);
    if (taskDetailView) {
      var taskDetailPanel = main.down('#taskDetailPanel' + this.moduleId);
      var previousTaskItem = taskDetailPanel.items.items;
      if (previousTaskItem.length > 0) {
        if (previousTaskItem[0].formName === taskId) {
          previousTaskItem[0].loadData(previousTaskItem[0].getLockUrl());
          return;
        }
      }
    }
    if (lockedUser && lockedUser !== this.user) {
      return;
    }
    var columnType = grid.panel.columnManager.columns[cellIndex].xtype;
    if (columnType !== 'actioncolumn') {
      if (record.data.action !== 'Info') {
        this.openTaskWindow(taskId, record.get('name'), taskDetailView);
      } else {
        this.getController().openInfoTaskWindow(grid, this.getController(), taskId, taskDetailView);
      }
    }
  }
}, openTaskWindow:function(taskId, taskName, isTaskDetailPanel) {
  taskName = taskName === void 0 ? '' : taskName;
  if (isTaskDetailPanel) {
    taskName = interaction.Support.getTranslation('TASKDETAIL_PRETEXT') + taskName;
  }
  var baseConfig = {baseUrl:this.baseUrl, moduleId:this.moduleId, lang:this.lang, tasksGrid:this, title:taskName, formName:taskId, taskName:taskName};
  if (!this.bpcPlugin) {
    if (isTaskDetailPanel) {
      var me = this;
      baseConfig.xtype = 'interactionTaskFormPanel';
      baseConfig.activateHelp = localStorage.getItem('activateHelp-' + this.moduleId);
      baseConfig.bodyPadding = 10;
      baseConfig.closable = true;
      baseConfig.isTaskDetailPanel = true;
      baseConfig.itemId = 'interactionTaskFormPanel' + this.moduleId;
      var taskDetailPanel = Ext.ComponentQuery.query('#taskDetailPanel' + this.moduleId)[0];
      var previousTaskItem = taskDetailPanel.items.items;
      if (previousTaskItem.length > 0) {
        if (previousTaskItem[0].formName !== taskId) {
          if (previousTaskItem[0].xtype === 'interactionTaskFormPanel') {
            var panelName = 'i_' + previousTaskItem[0].formName.replaceAll('-', '') + '_' + 'MainPanel';
            interaction.Support.destroyMainPanel(panelName);
            previousTaskItem[0].loadData(previousTaskItem[0].getUnlockUrl());
          } else if (previousTaskItem[0].itemId.startsWith('interactionTaskInfoPanel')) {
            interaction.Support.loadData(this.baseUrl + 'task/unlockAction' + '?instanceId\x3d' + previousTaskItem[0].moduleId + '\x26lang\x3d' + this.lang + '\x26id\x3d' + previousTaskItem[0].taskId);
          }
        }
        taskDetailPanel.remove(previousTaskItem[0]);
      }
      baseConfig.tools = [{iconCls:interaction.Support.getBpcIconCls('expand-alt'), itemId:'taskDetailExpandTool', tooltip:interaction.Support.getTranslation('EXPAND'), callback:function(event, toolEl, panelHeader) {
        var taskDetailPanel = this.up().up().ownerLayout.owner;
        taskDetailPanel.previousSize = taskDetailPanel.up().getSize();
        var mainPanel = taskDetailPanel.up().up();
        mainPanel.down('#taskGridContainer').setHidden(true);
        mainPanel.down('#masterDetailContainer').setHidden(true);
        taskDetailPanel.up().setSize(mainPanel.getSize());
        this.setHidden(true);
        this.up().down('#taskDetailCollapseTool').setHidden(false);
        mainPanel.updateLayout();
      }}, {itemId:'taskDetailCollapseTool', hidden:true, iconCls:interaction.Support.getBpcIconCls('compress-alt'), tooltip:interaction.Support.getTranslation('MINIMIZE'), callback:function(event, toolEl, panelHeader) {
        var taskDetailPanel = this.up().up().ownerLayout.owner;
        var mainPanel = taskDetailPanel.up().up();
        mainPanel.down('#taskGridContainer').setHidden(false);
        mainPanel.down('#masterDetailContainer').setHidden(false);
        taskDetailPanel.up().setSize(taskDetailPanel.previousSize);
        taskDetailPanel.previousSize = undefined;
        this.setHidden(true);
        this.up().down('#taskDetailExpandTool').setHidden(false);
        mainPanel.updateLayout();
      }}];
      taskDetailPanel.items.add(Ext.create(baseConfig));
      taskDetailPanel.updateLayout();
    } else {
      baseConfig.xtype = 'interactionTaskFormWindow';
      var window$4 = Ext.create(baseConfig);
      window$4.show();
    }
  } else {
    var t = this.up('tabpanel');
    previousTaskItem = t.query('interactionTaskFormPanel');
    if (previousTaskItem && previousTaskItem.length > 0) {
      previousTaskItem[0].loadData(previousTaskItem[0].getUnlockUrl());
      var panelName = 'i_' + previousTaskItem[0].formName.replaceAll('-', '') + '_' + 'MainPanel';
      interaction.Support.destroyMainPanel(panelName);
      t.remove(previousTaskItem[0]);
    }
    if (t) {
      t.query('interactionTaskFormPanel' + this.moduleId).map(function(p) {
        return p.close();
      });
      baseConfig.xtype = 'interactionTaskFormPanel';
      baseConfig.activateHelp = localStorage.getItem('activateHelp-' + this.moduleId);
      baseConfig.closable = true;
      baseConfig.itemId = 'interactionTaskFormPanel' + this.moduleId;
      var p = t.add(baseConfig);
      t.setActiveTab(p);
    } else {
    }
  }
}, reloadTasklistAfterFilterModification:function() {
  this.store.currentPage = 1;
  this.getController().getExtraParamsForFilterModification();
  this.store.load();
}});
Ext.define('interaction.view.tasklist.grids.Unit', {extend:'Ext.grid.Panel', alias:['widget.bpcInteractionUnitsGrid'], hideHeaders:true, border:true, header:true, title:interaction.Support.getTranslation('quickFilter'), selType:'rowmodel', selModel:{mode:'MULTI'}, unitIndex:undefined, roleSelection:undefined, typeSelection:undefined, selectedRecords:null, initComponent:function() {
  this.listeners = {cellclick:this.onCellClick.bind(this)};
  this.columns = [{header:'Name', dataIndex:'name', flex:1, renderer:function(v, p, r) {
    return !v || !v.length ? interaction.Support.getTranslation('allRoles') : v + (r.data.type == 'Role' ? '' : '(' + r.data.type + ')');
  }}, {dataIndex:'tasks', width:50, maxWidth:50, renderer:function(v, p, r) {
    return '(' + v + ')';
  }}];
  var isStateful = this.stateful;
  this.store = Ext.create('Ext.data.Store', {autoDestroy:true, autoLoad:true, unitsGrid:this, storeId:'tlextstoreUnitID', listeners:{beforeload:function(store) {
    try {
      store.unitsGrid.selectedRecords = store.unitsGrid.getSelection() || [];
    } catch (e) {
    }
  }, load:function(store, records, options) {
    var selectedIndex = this.unitIndex || 0;
    var intSelectedIndex = parseInt(selectedIndex);
    if (records != null) {
      if (!this.selectedRecords || this.selectedRecords.length == 0) {
        var filterKey = 'unit-filter-' + this.moduleId;
        var unitFilterVal = localStorage.getItem(filterKey);
        if (isStateful && unitFilterVal) {
          var selectedRecord;
          var index;
          var filteredRecords = [];
          for (var j = 0; j < records.length; j++) {
            if (records[j].data.tasks > 0) {
              filteredRecords.push(records[j]);
            }
            filteredRecords.sort(function(first, second) {
              return first.data.name.localeCompare(second.data.name);
            });
          }
          for (var i = 0; i < filteredRecords.length; i++) {
            var item = filteredRecords[i];
            if (item.get('name') == unitFilterVal) {
              selectedRecord = item;
              index = i;
              break;
            }
          }
          if (selectedRecord) {
            this.roleSelection = selectedRecord.get('name') || '';
            this.unitIndex = index;
            this.selectedRecords[0] = selectedRecord;
            this.getSelectionModel().select(index, true, false);
          }
        } else {
          this.selectedRecords[0] = records[0];
          this.getSelectionModel().select(intSelectedIndex, true, false);
        }
      } else {
        var record = records.filter(function(item) {
          return item.get('name') === this.selectedRecords[0].get('name');
        }.bind(this))[0];
        if (parseInt(record.get('tasks')) === 0) {
          this.selectedRecords[0] = record.store.data.items[record.store.data.items.length - 1];
          this.getSelectionModel().select(record.store.data.items.length - 1, true, true);
          this.unitIndex = intSelectedIndex - 1;
          this.loadTaskStore(this.selectedRecords[0]);
        } else {
          this.selectedRecords[0] = record;
          this.getSelectionModel().select(intSelectedIndex, true, true);
        }
      }
    }
  }.bind(this)}, model:'interaction.model.Unit', sorters:[{property:'name', direction:'ASC'}], filters:[function(item) {
    return item.get('name') === '' || item.get('tasks') > 0;
  }], proxy:{type:'ajax', url:this.baseUrl + 'task/units?instanceId\x3d' + this.moduleId + '\x26lang\x3d' + this.lang, reader:{type:'xml', rootProperty:'Units', record:'Unit', idProperty:'@name'}, simpleSortMode:true}});
  this.bbar = [{xtype:'tbfill'}, {iconCls:interaction.Support.getBpcIconCls(interaction.Support.keys.icons.processRole), hidden:true}, {iconCls:interaction.Support.getBpcIconCls(interaction.Support.keys.icons.user), hidden:true}, {xtype:'tbfill'}];
  this.callParent(arguments);
}, onCellClick:function(table, td, cellIndex, record, tr, rowIndex, e, eOpts) {
  this.unitIndex = rowIndex;
  this.loadTaskStore(record);
}, loadTaskStore:function(record) {
  var filterValue = record.get('name') || '';
  var type = record.get('type') || '';
  if (this.stateful) {
    localStorage.setItem('unit-filter-' + this.moduleId, filterValue);
    localStorage.setItem('unit-filter-type-' + this.moduleId, type);
  }
  this.selectedRecords[0] = record;
  this.setAndLoad(filterValue, type);
}, setAndLoad:function(role, type) {
  this.roleSelection = role;
  this.typeSelection = type;
  this.root.tasksGrid.reloadTasklistAfterFilterModification();
}});
Ext.define('interaction.view.tasklist.TasklistMain', {extend:'Ext.panel.Panel', alias:'widget.bpcInteractionMain', requires:['interaction.view.tasklist.grids.Tasks', 'interaction.view.tasklist.grids.Unit'], layout:'border', border:false, bodyBorder:false, header:false, bpcWidget:false, bpcPlugin:false, filters:undefined, eventReferences:undefined, initComponent:function() {
  var $jscomp$this = this;
  var stateful = this.bpcWidget === false;
  window.dataIS = {};
  window.ajaxValidation = {DOM:null, caller:null, submitter:null, errorNodesMustBeVisible:false, currentSelectedNode:null, currentSelectedErrorMessage:null, currentSelectedTimestamp:0, currentMouseposX:0, currentMouseposY:0, portletNS:'', form:null, allErrorNodesAreBlocked:false};
  if (localStorage.getItem('activateHelp-' + this.moduleId) == null) {
    localStorage.setItem('activateHelp-' + this.moduleId, BpcCommon.Api.getSetting(this.moduleId, 'activate_help'));
  }
  var config_params = BpcCommon.Api.getSetting(this.moduleId, 'tasklist_configuration_params') || {};
  var defaults = {moduleId:this.moduleId, root:this, baseUrl:interaction.Support.getBaseUrlForModuleId(this.moduleId), lang:BpcCommon.Api.getSetting('_core', 'language'), user:BpcCommon.Api.getUserName(), moduleProperties:config_params, initURL:'', customFields:interaction.Support.getCustomFields(this.moduleId), activateHelpLocal:localStorage.getItem('activateHelp-' + this.moduleId), bpcWidget:this.bpcWidget, bpcPlugin:this.bpcPlugin};
  var taskDetailWidth, taskDetailHeight, masterDetailWidth, masterDetailHeight;
  if (localStorage.getItem('interactionContainerConfig-' + this.moduleId)) {
    var parsedLocalStorage = JSON.parse(localStorage.getItem('interactionContainerConfig-' + this.moduleId));
    if (parsedLocalStorage.masterViewPosition === interaction.Support.getMasterViewPosition(config_params.masterViewPosition) && parsedLocalStorage.taskDetailPosition === interaction.Support.getTaskViewPosition(config_params.taskDetailPosition) && parsedLocalStorage.masterDetailView === interaction.Support.validateBooleanProperty(config_params.masterDetailView, true) && parsedLocalStorage.taskDetailView === interaction.Support.validateBooleanProperty(config_params.taskDetailView, false)) {
      taskDetailHeight = parsedLocalStorage.taskDetailSize ? parsedLocalStorage.taskDetailSize.height : undefined;
      taskDetailWidth = parsedLocalStorage.taskDetailSize ? parsedLocalStorage.taskDetailSize.width : undefined;
      masterDetailHeight = parsedLocalStorage.masterDetailSize ? parsedLocalStorage.masterDetailSize.height : undefined;
      masterDetailWidth = parsedLocalStorage.masterDetailSize ? parsedLocalStorage.masterDetailSize.width : undefined;
    }
  }
  this.unitsGrid = Ext.create(Ext.apply({}, {xtype:'bpcInteractionUnitsGrid', stateful:stateful, stateId:'unitGrid-' + this.moduleId, width:masterDetailWidth ? masterDetailWidth : interaction.Support.getIntegerProperty(config_params.masterViewSize, 150), height:masterDetailHeight, minHeight:75}, defaults));
  this.tasksGrid = Ext.create(Ext.apply({}, {xtype:'bpcInteractionTasksGrid', stateful:stateful, minHeight:75, stateId:'tasksGrid-' + this.moduleId, columns:interaction.Support.getTasklistColumns(this.moduleId)}, defaults));
  var taskDetailView = interaction.Support.validateBooleanProperty(config_params.taskDetailView, false);
  this.taskDetailPanel = Ext.create(Ext.apply({}, {xtype:'panel', region:'east', itemId:'taskDetailPanel' + this.moduleId, layout:'fit', minHeight:75, frame:'true', hideHeaders:true, width:taskDetailWidth ? taskDetailWidth : interaction.Support.getIntegerProperty(config_params.taskDetailSize, 500), height:taskDetailHeight, items:[interaction.Support.createEmptyTaskDetailPanel()]}, defaults));
  this.items = [].concat(interaction.Support.validateBooleanProperty(config_params.masterDetailView, true) ? [{xtype:'container', itemId:'masterDetailContainer', padding:this.bpcWidget ? '0 0 0 0 ' : '5 2 0 0', hidden:this.bpcWidget, region:interaction.Support.getMasterViewPosition(config_params.masterViewPosition), split:true, layout:'fit', items:[this.unitsGrid]}] : []).concat([{xtype:'container', itemId:'taskGridContainer', padding:this.bpcWidget ? '0 0 0 0 ' : '5 0 0 2', region:'center', layout:'fit', 
  items:[this.tasksGrid], listeners:{resize:function(width, height) {
    interaction.Support.saveSize($jscomp$this);
  }}}]).concat(interaction.Support.validateBooleanProperty(config_params.taskDetailView, true) ? [{xtype:'container', itemId:'taskDetailContainer', padding:this.bpcWidget ? '0 0 0 0 ' : '5 0 0 2', hidden:!taskDetailView, region:interaction.Support.getTaskViewPosition(config_params.taskDetailPosition), split:true, layout:'fit', items:[this.taskDetailPanel]}] : []);
  this.listeners = {beforedestroy:this.destroyGlobalEvents.bind(this)};
  this.callParent(arguments);
  this.eventReferences = Ext.on({destroyable:true, tasklistrefresh:this.onMessageRecieved.bind(this)});
}, destroyGlobalEvents:function() {
  if (this.eventReferences) {
    this.eventReferences.destroy();
  }
}, onMessageRecieved:function(obj) {
  try {
    if (obj && obj.properties && obj.properties.interactionModuleIds && Ext.isArray(obj.properties.interactionModuleIds) && obj.properties.interactionModuleIds.indexOf(this.moduleId) !== -1) {
      if (obj.properties.action && obj.properties.action === 'TaskLockUnlock') {
        var record = this.tasksGrid.store.findRecord('formName', obj.properties.taskId);
        if (record) {
          if (obj.properties.user && obj.properties.user != 'null') {
            record.set('locked', obj.properties.user);
          } else {
            record.set('locked', '');
            if (this.taskDetailPanel && this.taskDetailPanel.items.items.length > 0 && this.taskDetailPanel.items.items[0].xtype === 'interactionTaskFormPanel' && this.taskDetailPanel.items.items[0].form === obj.properties.taskId) {
              this.taskDetailPanel.items.removeAll();
              this.taskDetailPanel.items.add(interaction.Support.createEmptyTaskDetailPanel());
              this.updateLayout();
            }
          }
        }
      } else {
        this.tasksGrid.store.load();
        this.unitsGrid.store.load();
        if (this.taskDetailPanel && this.taskDetailPanel.items.items.length > 0 && this.taskDetailPanel.items.items[0].xtype === 'interactionTaskFormPanel' && this.taskDetailPanel.items.items[0].form === obj.properties.taskId && obj.properties.action && obj.properties.action === 'TaskRemoved') {
          this.taskDetailPanel.items.removeAll();
          this.taskDetailPanel.items.add(interaction.Support.createEmptyTaskDetailPanel());
          this.updateLayout();
        } else if (this.bpcPlugin) {
          var t = this.up('tabpanel');
          var formTabPanel = t.query('interactionTaskFormPanel' + this.moduleId);
          if (formTabPanel) {
            t.remove(formTabPanel);
          }
        }
      }
      return true;
    }
  } catch (e) {
    Ext.log({dump:e, msg:'Error onMessageRecieved'});
  }
}, loadData:function() {
  var $jscomp$this = this;
  var cmps = ['unitsGrid', 'tasksGrid'];
  var promises = cmps.map(function(cmpName) {
    return $jscomp$this.promisifiedStoreLoad(cmpName);
  });
  return Promise.all(promises);
}, promisifiedStoreLoad:function(cmpName) {
  var storeReference = this[cmpName].store;
  return new Promise(function(resolve) {
    storeReference.load({callback:function(records, operation, success) {
      resolve(success);
    }});
  });
}, resetAll:function() {
  localStorage.removeItem('activateHelp-' + this.moduleId);
  this.tasksGrid.activateHelpLocal = false;
  this.tasksGrid.toolbarReference.down('#helpCheckbox').setValue(false);
  localStorage.removeItem('unit-filter-' + this.moduleId);
  localStorage.removeItem('unit-filter-type-' + this.moduleId);
  localStorage.removeItem('interactionContainerConfig-' + this.moduleId);
  var config_params = BpcCommon.Api.getSetting(this.moduleId, 'tasklist_configuration_params') || {};
  Ext.state.Manager.clear(this.unitsGrid.stateId);
  this.unitsGrid.getSelectionModel().deselectAll();
  this.unitsGrid.unitIndex = 0;
  this.unitsGrid.roleSelection = '';
  this.unitsGrid.store.load();
  Ext.state.Manager.clear(this.tasksGrid.stateId);
  this.tasksGrid.store.sorters.clear();
  this.tasksGrid.filters.clearFilters();
  this.tasksGrid.store.sorters.add(new Ext.util.Sorter({property:'creation', direction:'DESC'}));
  this.tasksGrid.store.load();
  this.updateLayout();
}});
Ext.define('interaction.view.Main', {extend:'Ext.container.Container', requires:['interaction.view.tasklist.TasklistMain'], bpcSkipStateInjection:true, layout:'fit', moduleId:undefined, initComponent:function() {
  this.interactionMain = Ext.create({xtype:'bpcInteractionMain', moduleId:this.moduleId});
  this.items = [this.interactionMain];
  this.bpcModuleHeader = Ext.createByAlias('widget.interactionModuleHeader', {moduleId:this.moduleId, moduleInstance:this});
  Ext.Ajax.on('requestcomplete', function() {
    Ext.getBody().unmask();
  });
  this.callParent(arguments);
}});
Ext.define('interaction.view.ModuleHeader', {extend:'Ext.container.Container', alias:'widget.interactionModuleHeader', layout:{type:'hbox', align:'stretch'}, moduleId:undefined, moduleInstance:undefined, onFilterReset:function() {
  this.moduleInstance.interactionMain.tasksGrid.resetGridFilters();
}, onRefreshClick:function() {
  this.moduleInstance.interactionMain.loadData();
}, onResetAllClick:function() {
  this.moduleInstance.interactionMain.resetAll();
}, initComponent:function() {
  this.quickfilterBar = Ext.create({xtype:'toolbar', layout:{type:'hbox'}, overflowHandler:'scroller', items:[{iconCls:interaction.Support.getBpcIconCls('fa-times'), handler:this.onFilterReset.bind(this), tooltip:interaction.Support.getTranslation('DEACTIVATE_FILTER')}, {iconCls:interaction.Support.getBpcIconCls('fa-sync'), handler:this.onRefreshClick.bind(this), tooltip:interaction.Support.getTranslation('RELOAD')}, {iconCls:interaction.Support.getBpcIconCls('x-fal fa-trash-alt'), handler:this.onResetAllClick.bind(this), 
  tooltip:interaction.Support.getTranslation('RESET_ALL')}]});
  this.filterBar = Ext.create({xtype:'toolbar', layout:{type:'hbox', align:'stretch'}, overflowHandler:'scroller', flex:1});
  this.searchfield = Ext.create({xtype:'textfield', hidden:!BpcCommon.Api.getSetting(this.moduleId, 'searchFieldVisible'), emptyText:'Search', margin:'0 25 0 10', listeners:{change:function(f, newVal, oldVal) {
    f.getTrigger('reset').setVisible(newVal && newVal.length > 0);
  }.bind(this)}, triggers:{reset:{cls:interaction.Support.keys.icons.remove, hidden:true, scope:this, handler:function() {
    this.searchfield.setValue(undefined);
  }}}, width:180});
  var filterConfig = BpcCommon.Api.getSetting(this.moduleId, 'filterConfiguration');
  var useUIFilters = !Ext.Object.isEmpty(filterConfig);
  this.filterBar.setVisible(useUIFilters);
  this.items = [this.searchfield, {xtype:'tbfill'}, this.filterBar, {xtype:'tbfill'}, this.quickfilterBar];
  this.callParent(arguments);
  if (useUIFilters) {
    this.moduleInstance.interactionMain.unitsGrid.store.on('load', function(s, records, success, operation) {
      this.filterBar.removeAll();
      if (success) {
        var btnConfigs = records.map(function(rec) {
          var btn = {xtype:'button'};
          btn.type = rec.get('type');
          var count = rec.get('tasks');
          btn.tooltip = count + ' Tasks';
          btn.tasksCount = count;
          var name = rec.get('name') || '';
          btn.name = name.length > 0 ? name : 'ALL';
          btn.iconCls = interaction.Support.getBpcIconCls(btn.type ? btn.type.toLowerCase() === 'role' ? interaction.Support.keys.icons.processRole : interaction.Support.keys.icons.user : interaction.Support.keys.icons.all);
          btn.text = name.toUpperCase();
          return btn;
        }).filter(function(btn) {
          return btn.type && btn.type.toLowerCase() === 'role' || btn.name === 'ALL';
        });
        this.filterBar.add(btnConfigs);
      } else {
        this.filterBar.removeAll();
      }
    }.bind(this));
  }
}});
Ext.define('interaction.config.InstanceSettings', {extend:'Ext.panel.Panel', alias:['widget.interactionInstanceSettings'], layout:{type:'vbox', align:'stretch'}, padding:'5 5 5 5', initComponent:function() {
  this.settingsFields = Ext.create({flex:3, xtype:'panel', title:'Settings', frame:'true', scrollable:'true', settingId:'tasklist_configuration_params', layout:{type:'hbox', align:'stretch'}, defaults:{xtype:'container', flex:1, layout:{type:'vbox', align:'stretch'}, padding:'5 5 5 5', items:[]}, items:[], getValues:function() {
    var me = this;
    var fields = me.query('[objSettingKey]');
    var settings = {};
    fields.map(function(f) {
      settings[f.objSettingKey] = f.getValue();
    });
    return settings;
  }});
  this.customFieldsGrid = Ext.create({xtype:'grid', flex:1, title:'User defined fields', settingId:'taskList_custom_field_params', plugins:{ptype:'cellediting', clicksToEdit:1}, columns:[{dataIndex:'name', text:interaction.Support.getTranslation('FIELD')}, {dataIndex:'de', text:interaction.Support.getTranslation('GERMAN')}, {dataIndex:'en', text:interaction.Support.getTranslation('ENGLISH')}, {xtype:'actioncolumn', width:60, items:[{iconCls:interaction.Support.getBpcIconCls(interaction.Support.keys.icons.copy), 
  handler:function(tv, rowIndex, colIndex) {
    var data = tv.store.getAt(rowIndex).getData();
    var $jscomp$destructuring$var0 = data;
    var name = $jscomp$destructuring$var0.name;
    var de = $jscomp$destructuring$var0.de;
    var en = $jscomp$destructuring$var0.en;
    tv.store.add({name:name || '', de:de || '', en:en || ''});
  }}, {iconCls:interaction.Support.getBpcIconCls(interaction.Support.keys.icons.remove), handler:function(tv, rowIndex, colIndex) {
    tv.store.removeAt(rowIndex);
  }}]}].map(function(i) {
    if (i.xtype === 'actioncolumn') {
    } else {
      i.flex = 1;
      i.editor = {completeOnEnter:false, field:{xtype:'textfield', allowBlank:false}};
    }
    return i;
  }), store:Ext.create('Ext.data.Store', {data:[]}), viewConfig:{emptyText:interaction.Support.getTranslation('NO_CUSTOM_FIELDS')}, getValues:function() {
    var me = this;
    var setting = {Fields:[]};
    me.store.each(function(r) {
      setting.Fields.push({name:r.get('name'), en:r.get('en'), de:r.get('de')});
    });
    return setting;
  }});
  this.items = [this.settingsFields, {xtype:'splitter'}, this.customFieldsGrid];
  this.callParent(arguments);
}, loadData:function(moduleId) {
  this.moduleId = moduleId;
  this.settingsFields.removeAll();
  this.customFieldsGrid.store.removeAll();
  if (moduleId) {
    var params = BpcCommon.Api.getSetting(moduleId, 'tasklist_configuration_params') || {};
    var fieldDefinitions = [];
    fieldDefinitions.push({xtype:'numberfield', labelWidth:200, objSettingKey:'refreshSeconds', fieldLabel:interaction.Support.getTranslation('refreshSeconds'.toUpperCase()), value:parseInt(params.refreshSeconds), minValue:0});
    fieldDefinitions.push({xtype:'numberfield', labelWidth:200, objSettingKey:'timeoutWarningInPercent', fieldLabel:interaction.Support.getTranslation('timeoutWarningInPercent'.toUpperCase()), value:parseInt(params.timeoutWarningInPercent), minValue:0, maxValue:100});
    fieldDefinitions.push({xtype:'checkbox', labelWidth:200, objSettingKey:'directSubmit', fieldLabel:interaction.Support.getTranslation('directSubmit'.toUpperCase()), value:params.directSubmit, minValue:0});
    fieldDefinitions.push({xtype:'checkbox', labelWidth:200, objSettingKey:'directLockAndUnlock', fieldLabel:interaction.Support.getTranslation('directLockAndUnlock'.toUpperCase())});
    fieldDefinitions.push({xtype:'checkbox', labelWidth:200, objSettingKey:'lockedTasksEnabled', fieldLabel:interaction.Support.getTranslation('lockedTasksEnabled'.toUpperCase()), value:params.lockedTasksEnabled});
    fieldDefinitions.push({xtype:'checkbox', labelWidth:200, objSettingKey:'directToDelegate', fieldLabel:interaction.Support.getTranslation('directToDelegate'.toUpperCase()), value:params.directToDelegate});
    fieldDefinitions.push({xtype:'checkbox', labelWidth:200, objSettingKey:'directDelegateToAll', fieldLabel:interaction.Support.getTranslation('directDelegateToAll'.toUpperCase()), value:params.directDelegateToAll});
    fieldDefinitions.push({xtype:'checkbox', labelWidth:200, objSettingKey:'enableDIN5007Sort', fieldLabel:interaction.Support.getTranslation('enableDIN5007Sort'.toUpperCase()), value:params.enableDIN5007Sort});
    fieldDefinitions.push({xtype:'numberfield', labelWidth:200, objSettingKey:'pageRows', fieldLabel:interaction.Support.getTranslation('pageRows'.toUpperCase()), value:parseInt(params.pageRows), minValue:0, maxValue:100});
    fieldDefinitions.push({xtype:'checkbox', labelWidth:200, objSettingKey:'masterDetailView', fieldLabel:interaction.Support.getTranslation('masterDetailView'.toUpperCase()), value:params.masterDetailView});
    fieldDefinitions.push({xtype:'combo', labelWidth:200, objSettingKey:'masterViewPosition', fieldLabel:interaction.Support.getTranslation('masterViewPosition'.toUpperCase()), value:params.masterViewPosition, multiSelect:false, store:['east', 'north', 'south', 'west']});
    fieldDefinitions.push({xtype:'numberfield', labelWidth:200, objSettingKey:'masterViewSize', fieldLabel:interaction.Support.getTranslation('masterViewSize'.toUpperCase()), value:parseInt(params.masterViewSize), minValue:0});
    fieldDefinitions.push({xtype:'checkbox', labelWidth:200, objSettingKey:'pagingBarAtTop', fieldLabel:interaction.Support.getTranslation('pagingBarAtTop'.toUpperCase()), value:params.pagingBarAtTop});
    fieldDefinitions.push({xtype:'checkbox', labelWidth:200, objSettingKey:'staticEntries', fieldLabel:interaction.Support.getTranslation('staticEntries'.toUpperCase()), value:params.staticEntries});
    fieldDefinitions.push({xtype:'checkbox', labelWidth:200, objSettingKey:'adHocStarter', fieldLabel:interaction.Support.getTranslation('adHocStarter'.toUpperCase()), value:params.adHocStarter});
    fieldDefinitions.push({xtype:'checkbox', labelWidth:200, objSettingKey:'activateHelp', fieldLabel:interaction.Support.getTranslation('activateHelp'), value:BpcCommon.Api.getSetting(moduleId, 'activate_help')});
    this.settingsFields.add({items:fieldDefinitions.slice(0, 8)});
    this.settingsFields.add({items:fieldDefinitions.slice(8)});
    var fieldsParams = BpcCommon.Api.getSetting(moduleId, 'taskList_custom_field_params') || {};
    var $jscomp$destructuring$var1 = fieldsParams;
    var Fields = $jscomp$destructuring$var1.Fields;
    this.customFieldsGrid.store.add(Fields || []);
  }
}, getSettingValues:function() {
  var $jscomp$this = this;
  var settings = {tasklist_configuration_params:undefined, taskList_custom_field_params:undefined};
  Object.keys(settings).map(function(name) {
    var cmps = $jscomp$this.query('[settingId\x3d' + name + ']');
    return cmps[0];
  }).map(function(cmp) {
    settings[cmp.settingId] = cmp.getValues();
  });
  settings.activate_help = settings.tasklist_configuration_params.activateHelp;
  return settings;
}});
Ext.define('interaction.config.Main', {extend:'BpcCommon.component.panel.moduleConfigurationComponents.Wrapper', alias:['widget.interactionConfig'], initComponent:function() {
  this.callParent(arguments);
  this.saveButton.setUI('primary');
  this.saveButton.setText(interaction.Support.getTranslation('SAVE'));
  this.saveButton.setIconCls(BpcCommon.util.Icons.getBpcIconCls('fa-save'));
  this.saveButton.setHandler(this.onSaveButtonClick, this);
  this.saveButton.setDisabled(false);
  this.setIconCls(BpcCommon.util.Icons.getBpcIconCls('fa-cogs'));
  this.setTitle(interaction.Support.getTranslation('TASK_LIST_CONFIGURATION'));
  this.resetButton.setVisible(false);
}, interactionInstanceSettings:undefined, onSelect:function(grid, record) {
  this.settingsWrapper.removeAll();
  this.interactionInstanceSettings = Ext.create({xtype:'interactionInstanceSettings'});
  this.interactionInstanceSettings.loadData(record.get('moduleId'));
  this.settingsWrapper.add(this.interactionInstanceSettings);
}, onSaveButtonClick:function(btn) {
  var $jscomp$this = this;
  if (this.interactionInstanceSettings) {
    var settingData = this.interactionInstanceSettings.getSettingValues();
    var promises = Object.keys(settingData).map(function(settingName) {
      return BpcCommon.Api.getSetting($jscomp$this.interactionInstanceSettings.moduleId, settingName, true);
    }).map(function(settingModel) {
      settingModel.data.value = settingData[settingModel.id];
      return $jscomp$this.promisifyModelSave(settingModel);
    });
    Promise.all(promises).then(function(successArray) {
      BpcCommon.Api.showNotification(interaction.Support.getTranslation(successArray.indexOf(false) === -1 ? 'INTERACTION_SETTINGS_SAVE_SUCCESS' : 'INTERACTION_SETTINGS_SAVE_ERROR'));
    });
  }
}, promisifyModelSave:function(bpcSettingModel) {
  return new Promise(function(resolve, reject) {
    bpcSettingModel.save({failure:function() {
      resolve(false);
    }, success:function() {
      resolve(true);
    }});
  });
}});
Ext.define('interaction.view.tasklist.TaskPanel', {extend:'interaction.components.HtmlPanel', alias:'widget.interactionTaskFormPanel', itemId:'interactionTaskFormPanel' + this.moduleId, bodyStyle:'background-color: white', autoScroll:true, fireUnlock:true, formName:undefined, taskName:undefined, moduleId:undefined, lang:undefined, tasksGrid:undefined, activateHelp:undefined, isExpandable:false, loadData:function(url) {
  interaction.Support.loadData(url).then(function(successResponse) {
  }, function(response) {
    if (response.status === 423) {
      Ext.Msg.alert(interaction.Support.getTranslation('warning'), interaction.Support.getTranslation('taskLocked'));
    }
  });
}, initComponent:function() {
  var $jscomp$this = this;
  this.unlockUrl = this.getUnlockUrl();
  this.lockUrl = this.getLockUrl();
  this.form = this.formName;
  this.dataIS = new Object();
  this.ajaxValidation = {DOM:null, caller:null, submitter:null, errorNodesMustBeVisible:false, currentSelectedNode:null, currentSelectedErrorMessage:null, currentSelectedTimestamp:0, currentMouseposX:0, currentMouseposY:0, portletNS:'', form:null, allErrorNodesAreBlocked:false};
  this.loader = {autoLoad:true, scripts:true, url:this.getDataUrl(), loadMask:true, listeners:{load:function(loader, response) {
    var comp = $jscomp$this;
    comp.tasksGrid.store.load({callback:function(records, operation, success) {
      if (success) {
        var match = records.filter(function(r) {
          return r.get('formName') === comp.formName;
        });
        if (match.length) {
          $jscomp$this.changeTitle(match[0].get('name'));
        }
      }
    }});
  }}};
  this.listeners = {beforeclose:function(win) {
    $jscomp$this.loadData(win.unlockUrl);
  }, close:function(win) {
    if (win.isTaskDetailPanel) {
      if (win.ownerLayout.owner.up().getHeight() == win.ownerLayout.owner.up().up().getHeight() && win.ownerLayout.owner.up().getWidth() == win.ownerLayout.owner.up().up().getWidth()) {
        win.ownerLayout.owner.up().setSize(win.ownerLayout.owner.previousSize);
        win.ownerLayout.owner.previousSize = undefined;
        win.ownerLayout.owner.up().up().down('#taskGridContainer').setHidden(false);
        win.ownerLayout.owner.up().up().down('#masterDetailContainer').setHidden(false);
        win.ownerLayout.owner.up().up().updateLayout();
      }
      win.ownerLayout.owner.items.remove(win);
      win.ownerLayout.owner.items.add(interaction.Support.createEmptyTaskDetailPanel());
      win.ownerLayout.owner.updateLayout();
      var panelName = 'i_' + win.formName.replaceAll('-', '') + '_' + 'MainPanel';
      interaction.Support.destroyMainPanel(panelName);
    }
  }};
  this.callParent(arguments);
}, listeners:{close:function(panel) {
  if (panel.el.up().component.xtype === 'monitorDetailTabPanel') {
    var panelName = 'i_' + panel.formName.replaceAll('-', '') + '_' + 'MainPanel';
    interaction.Support.destroyMainPanel(panelName);
  }
}}, getDataUrl:function() {
  var p = this.getBaseParams();
  p.activateHelp = this.activateHelp;
  return this.getBaseUrl() + 'task/data/' + this.formName + '?' + Ext.Object.toQueryString(p);
}, getBaseParams:function() {
  return {instanceId:this.moduleId, lang:this.lang, bpcComponentId:this.id};
}, getBaseUrl:function() {
  return this.baseUrl;
}, getUnlockUrl:function() {
  var p = this.getBaseParams();
  p.id = this.formName;
  return this.getBaseUrl() + 'task/unlockAction' + '?' + Ext.Object.toQueryString(p);
}, getLockUrl:function() {
  var p = this.getBaseParams();
  p.id = this.formName;
  return this.getBaseUrl() + 'task/lockAction' + '?' + Ext.Object.toQueryString(p);
}, changeTitle:function(taskName) {
  taskName = taskName === void 0 ? '' : taskName;
  var comp = this.up('interactionTaskFormWindow');
  if (this.isTaskDetailPanel) {
    taskName = interaction.Support.getTranslation('TASKDETAIL_PRETEXT') + taskName;
  }
  if (comp) {
    comp.setTitle(taskName);
  }
  this.setTitle(taskName);
}, initIS:function(params, dataIS) {
  try {
    this.dataIS = dataIS || {};
    if (this.dataIS['ajaxLoad']) {
      try {
        if (this.ajaxValidation.form !== null) {
          this.ajaxValidation.form.style['cursor'] = 'default';
        }
      } catch (e) {
      }
      this.dataIS['AjaxValidationIsCurrentlyRunning'] = false;
    }
  } catch (e$5) {
    Ext.log('Exception in InitIS:' + e$5.message);
  }
  window.dataIS['ajaxLoad'] = false;
}, updateDataISArray:function(variable, value) {
  if (!this.dataIS[variable]) {
    this.dataIS[variable] = new Array();
  }
  this.dataIS[variable].push(value);
}, updateDataISProp:function(property, value) {
  this.dataIS[property] = value;
}, submit:function(event, ns, url) {
  if (event) {
    event.preventDefault();
  }
  if (interaction.services.Script.doSubmitIS(ns, this)) {
    this.dataIS[ns + 'done'] = false;
    interaction.services.Script.ajaxCallForSubmit(ns, url, this.moduleId);
  }
  return false;
}, changeFormActionToUploadIS:function(newAction, namespace) {
  interaction.services.Script.changeFormActionToUploadIS(newAction, namespace, this);
}, addPatternMatchIS:function(pattern, id, errorText, namespace) {
  interaction.services.Script.addPatternMatchIS(pattern, id, errorText, namespace, this);
}, backIS:function(namespace) {
  interaction.services.Script.backIS(namespace, this);
}, setSubmitPropertyIS:function(target, validate, namespace) {
  interaction.services.Script.setSubmitPropertyIS(target, validate, namespace, this);
}, ajaxSubmitIS:function(trigger, url, groupOrGroupId, jump) {
  interaction.services.Script.ajaxSubmitIS(trigger, url, groupOrGroupId, jump, this);
}, showHelpToolTip:function(ns, node) {
  interaction.services.Script.showHelpToolTip(ns, node, this);
}, setDataIS:function(dataIS) {
  this.dataIS = dataIS;
}});
Ext.define('interaction.view.tasklist.grids.TasksController', {extend:'Ext.app.ViewController', alias:'controller.tasks', view:'bpcInteractionTasksGrid', getExtraParamsForFilterModification:function() {
  var proxy = this.view.store.getProxy();
  proxy.extraParams.filterComparison = [];
  proxy.extraParams.filterField = [];
  proxy.extraParams.filterValue = [];
  var mystoreFilter = this.view.store.filters;
  if (this.view.filters) {
    mystoreFilter = this.view.filters.store.filters;
  }
  var item = mystoreFilter.items;
  var userType = this.view.root.unitsGrid.roleSelection || '';
  var roleType = this.view.root.unitsGrid.typeSelection || '';
  if (this.view.initURL == '') {
    this.view.initURL = this.view.baseUrl + 'task/tasks' + '?instanceId\x3d' + this.view.moduleId + '\x26lang\x3d' + this.view.lang;
  }
  var newfilterUrl = this.view.initURL + '\x26filterField\x3dUnit/@name\x26filterValue\x3d' + userType + '\x26filterComparison\x3deq' + '\x26comparisonType\x3d' + '\x26filterField\x3dUnit/@type\x26filterValue\x3d' + roleType + '\x26filterComparison\x3deq' + '\x26comparisonType\x3d';
  if (item.length > 0) {
    var wildcardLocStorage = localStorage.getItem('interaction-wildcard-' + this.view.moduleId);
    var wildcardFilterArray;
    if (wildcardLocStorage) {
      wildcardFilterArray = wildcardLocStorage.split(';');
    }
    var $jscomp$loop$6 = {};
    var k = 0;
    for (; k < item.length; $jscomp$loop$6 = {$jscomp$loop$prop$comparisonType$7:$jscomp$loop$6.$jscomp$loop$prop$comparisonType$7}, k++) {
      var filterUrl = void 0;
      $jscomp$loop$6.$jscomp$loop$prop$comparisonType$7 = '';
      if (item[k]._property != undefined && item[k]._value != undefined) {
        var columnName = item[k]._property;
        var columnValue = item[k]._value;
        if (columnName == 'creation' || columnName == 'expiration') {
          var dateInShort = Ext.Date.format(item[k]._value, 'm/d/Y H:i:s');
          var operator = item[k].config.operator;
          filterUrl = '\x26filterField\x3d' + columnName + '\x26filterValue\x3d' + dateInShort + '\x26filterComparison\x3d' + operator;
          newfilterUrl = newfilterUrl.concat(filterUrl);
        } else {
          filterUrl = '\x26filterField\x3d' + columnName + '\x26filterValue\x3d' + columnValue;
          $jscomp$loop$6.$jscomp$loop$prop$comparisonType$7 = 'LIKE';
          if (wildcardFilterArray) {
            wildcardFilterArray.forEach(function($jscomp$loop$6) {
              return function(wcfilter) {
                if (wcfilter.includes(columnName + ':WILDCARD')) {
                  $jscomp$loop$6.$jscomp$loop$prop$comparisonType$7 = 'WILDCARD';
                }
              };
            }($jscomp$loop$6));
          }
          newfilterUrl = newfilterUrl.concat(filterUrl + '\x26filterComparison\x3d');
        }
        newfilterUrl = newfilterUrl.concat('\x26comparisonType\x3d' + $jscomp$loop$6.$jscomp$loop$prop$comparisonType$7);
      }
    }
  }
  if (this.view.root.filters) {
    this.view.root.filters.map(function(obj) {
      newfilterUrl += '\x26filterField\x3d' + encodeURIComponent(obj.filterField) + '\x26filterValue\x3d' + encodeURIComponent(obj.filterValue) + '\x26filterComparison\x3d';
    });
  }
  proxy.setUrl(newfilterUrl);
}, openInfoTaskWindow:function(grid, tasksController, taskId, taskDetailView) {
  var storeView = grid.store.storeView;
  interaction.Support.loadData(storeView.baseUrl + 'task/lockAction' + '?instanceId\x3d' + storeView.moduleId + '\x26lang\x3d' + storeView.lang + '\x26id\x3d' + taskId);
  if (taskDetailView) {
    var taskDetailPanel = storeView.up().up().down('#taskDetailPanel' + storeView.moduleId);
    var previousTaskItem = taskDetailPanel.items.items;
    if (previousTaskItem.length > 0) {
      if (previousTaskItem[0].xtype === 'interactionTaskFormPanel') {
        previousTaskItem[0].loadData(previousTaskItem[0].getUnlockUrl());
      } else if (previousTaskItem[0].itemId.startsWith('interactionTaskInfoPanel')) {
        interaction.Support.loadData(storeView.baseUrl + 'task/unlockAction' + '?instanceId\x3d' + previousTaskItem[0].moduleId + '\x26lang\x3d' + storeView.lang + '\x26id\x3d' + previousTaskItem[0].taskId);
      }
      taskDetailPanel.remove(previousTaskItem[0]);
    }
    var infoPanel = Ext.create('Ext.panel.Panel', {itemId:'interactionTaskInfoPanel' + storeView.moduleId, title:interaction.Support.getTranslation('info'), taskId:taskId, bodyPadding:10, moduleId:storeView.moduleId, layout:{align:'stretch', padding:5}, items:[{layout:{type:'hbox'}, items:[{html:'\x3cspan class\x3d"x-fal fa-question-circle fa-3x" \x3e\x3c/span\x3e' + interaction.Support.getTranslation('submitInfoTask')}]}, {layout:{type:'hbox'}, items:[{xtype:'button', text:'Yes', handler:function() {
      interaction.Support.loadData(storeView.baseUrl + 'task/unlockAction' + '?instanceId\x3d' + storeView.moduleId + '\x26lang\x3d' + storeView.lang + '\x26id\x3d' + taskId);
      interaction.Support.callAjaxAndRefresh(storeView.baseUrl + 'task/submitInfo?id\x3d' + taskId + '\x26instanceId\x3d' + storeView.moduleId + '\x26user\x3d' + storeView.user);
      infoPanel.destroy();
      taskDetailPanel.items.add(interaction.Support.createEmptyTaskDetailPanel());
      taskDetailPanel.updateLayout();
    }}, {xtype:'button', text:'No', handler:function() {
      interaction.Support.loadData(storeView.baseUrl + 'task/unlockAction' + '?instanceId\x3d' + storeView.moduleId + '\x26lang\x3d' + storeView.lang + '\x26id\x3d' + taskId);
      infoPanel.destroy();
      taskDetailPanel.items.add(interaction.Support.createEmptyTaskDetailPanel());
      taskDetailPanel.updateLayout();
    }}]}]});
    taskDetailPanel.add(infoPanel);
    taskDetailPanel.updateLayout();
  } else {
    var showTaskInformation = BpcCommon.Api.getSetting(this.view.moduleId, 'showTaskInformation');
    var message = '';
    if (showTaskInformation) {
      var taskName = '';
      var taskDescription = '';
      if (grid.getSelection()[0].data.name != undefined) {
        taskName = grid.getSelection()[0].data.name;
      }
      if (grid.getSelection()[0].data.description != undefined) {
        taskDescription = grid.getSelection()[0].data.description;
      }
      message = '\x3cdiv style\x3d"font-weight: bold; font-size: 16px;"\x3e' + interaction.Support.getTranslation('submitInfoTask') + '\x3c/div\x3e' + '\x3cdiv style\x3d"font-weight: bold; font-size: 13px;"\x3e' + '\x3cbr/\x3e' + Ext.String.htmlEncode2(taskName) + '\x3c/div\x3e' + '\x3cdiv style\x3d"font-size: 13px; padding-right: 15px; text-align: justify"\x3e' + '\x3cbr/\x3e' + Ext.String.htmlEncode2(taskDescription) + '\x3c/div\x3e';
    } else {
      message = interaction.Support.getTranslation('submitInfoTask');
    }
    Ext.Msg.show({title:interaction.Support.getTranslation('info'), msg:message, buttons:Ext.Msg.YESNO, fn:function(btn, text, opt) {
      var grid = opt.config.grid, tasksController = opt.config.tasksController, taskId = opt.config.taskId;
      var storeView = grid.store.storeView;
      interaction.Support.loadData(storeView.baseUrl + 'task/unlockAction' + '?instanceId\x3d' + storeView.moduleId + '\x26lang\x3d' + storeView.lang + '\x26id\x3d' + taskId);
      if (btn !== 'yes') {
        return;
      }
      interaction.Support.callAjaxAndRefresh(storeView.baseUrl + 'task/submitInfo?id\x3d' + taskId + '\x26instanceId\x3d' + storeView.moduleId + '\x26user\x3d' + tasksController.getView().user);
    }, buttonText:{yes:interaction.Support.getTranslation('yesText'), no:interaction.Support.getTranslation('noText')}, icon:Ext.MessageBox.QUESTION, config:{grid:grid, tasksController:tasksController, taskId:taskId}});
  }
}, submitInfoTask:function(btn, text, opt) {
  var grid = opt.config.grid, tasksController = opt.config.tasksController, taskId = opt.config.taskId;
  var storeView = grid.store.storeView;
  var unlockInfoUrl = storeView.baseUrl + 'task/unlockAction' + '?instanceId\x3d' + storeView.moduleId + '\x26lang\x3d' + storeView.lang + '\x26id\x3d' + taskId;
  interaction.Support.loadData(unlockInfoUrl);
  if (btn !== 'yes') {
    return;
  }
  var submitInfoUrl = storeView.baseUrl + 'task/submitInfo?id\x3d' + taskId + '\x26instanceId\x3d' + storeView.moduleId + '\x26user\x3d' + tasksController.getView().user;
  interaction.Support.callAjaxAndRefresh(submitInfoUrl);
}, reloadTasklist:function(cb) {
  this.getView().store.load({callback:cb});
}});
Ext.define('interaction.view.tasklist.grids.dateTime.picker.DateTimeMenu', {extend:'Ext.menu.Menu', alias:'widget.datetimemenu', hideOnClick:true, pickerId:null, enableFocusableContainer:false, initComponent:function() {
  var me = this, cfg, pickerConfig;
  if (me.pickerCfg) {
    pickerConfig = Ext.apply({cls:Ext.baseCSSPrefix + 'menu-date-item', margin:0, border:false, id:me.pickerId, xtype:'datetimepicker'}, me.pickerCfg);
  } else {
    cfg = Ext.apply({}, me.initialConfig);
    delete cfg.listeners;
    pickerConfig = Ext.applyIf({cls:Ext.baseCSSPrefix + 'menu-date-item', margin:0, border:false, id:me.pickerId, xtype:'datetimepicker'}, cfg);
  }
  Ext.apply(me, {showSeparator:false, plain:true, bodyPadding:0, items:[pickerConfig]});
  me.callParent();
  me.picker = me.down('datetimepicker');
  me.relayEvents(me.picker, ['select']);
  if (me.hideOnClick) {
    me.on('select', me.hidePickerOnSelect, me);
  }
}, onEscapeKey:function(e) {
  if (this.floating && this.ownerCmp && this.ownerCmp.focus) {
    this.ownerCmp.focus();
  }
}, hidePickerOnSelect:function() {
  Ext.menu.Manager.hideAll();
}});
Ext.define('interaction.view.tasklist.grids.dateTime.picker.DateTimePlugin', {extend:'Ext.container.Container', alias:'widget.datetimepicker', date:undefined, initComponent:function() {
  var me = this;
  Ext.apply(me, {layout:{type:'vbox', align:'stretch'}, border:1, margin:5, items:[{itemId:'date', xtype:'datepicker', footerButtonUI:'', border:false, listeners:{select:function(comp, date) {
    me.date = date;
  }}}, {xtype:'container', layout:{type:'hbox', pack:'center'}, defaults:{xtype:'numberfield', minValue:0, stepValue:1, minWidth:55, height:35, width:55, maxWidth:65, flex:1, margin:3, maxLength:2, allowBlank:false, allowDecimals:false, allowExponential:false, allowOnlyWhitespace:false, enforceMaxLength:true, listeners:{focusleave:function(comp) {
    if (!comp.getValue()) {
      comp.setValue(0);
    }
  }, change:function(comp, newVal, oldVal) {
    if (newVal > comp.maxValue || newVal < comp.minValue) {
      comp.setValue(oldVal);
    }
  }}}, items:[{itemId:'hours', maxValue:23, value:0, fieldStyle:'width: 100%; height: 100%; margin: 0px'}, {xtype:'displayfield', width:25, minWidth:25, maxWidth:25, flex:0, value:'hh'}, {itemId:'minutes', maxValue:59, value:0, fieldStyle:'width: 100%; height: 100%; margin: 0px'}, {xtype:'displayfield', width:25, minWidth:25, maxWidth:25, flex:0, value:'mm'}, {itemId:'seconds', maxValue:59, value:0, fieldStyle:'width: 100%; height: 100%; margin: 0px'}, {xtype:'displayfield', width:25, minWidth:25, 
  maxWidth:25, flex:0, value:'ss'}]}, {xtype:'container', layout:{type:'hbox', pack:'center'}, defaults:{xtype:'button', miWidth:55, maxWidth:65, flex:1, margin:5}, items:[{text:'OK', listeners:{click:function() {
    var date = me.date || new Date(), year = date.getFullYear(), month = date.getMonth(), date = date.getDate(), hours = me.down('#hours').getValue() || 0, minutes = me.down('#minutes').getValue() || 0, seconds = me.down('#seconds').getValue() || 0, millis = 0;
    me.fireEvent('select', me, new Date(year, month, date, hours, minutes, seconds, millis));
  }}}, {text:this.todayText ? this.todayText : 'Today', listeners:{click:function() {
    var today = new Date(), year = today.getFullYear(), month = today.getMonth(), date = today.getDate(), hours = me.down('#hours').getValue() || 0, minutes = me.down('#minutes').getValue() || 0, seconds = me.down('#seconds').getValue() || 0, millis = 0;
    me.fireEvent('select', me, new Date(year, month, date, hours, minutes, seconds, millis));
  }}}, {text:this.nowText ? this.nowText : 'Now', listeners:{click:function() {
    me.fireEvent('select', me, new Date());
  }}}]}]});
  me.callParent();
}, setValue:function(value) {
  var me = this;
  me.down('datepicker').setValue(value);
  if (value) {
    me.down('#hours').setValue(value.getHours());
    me.down('#minutes').setValue(value.getMinutes());
    me.down('#seconds').setValue(value.getSeconds());
  } else {
    me.down('#hours').setValue(0);
    me.down('#minutes').setValue(0);
    me.down('#seconds').setValue(0);
  }
}});
Ext.define('interaction.view.tasklist.grids.dateTime.picker.DateTimePicker', {extend:'Ext.grid.filters.filter.TriFilter', alias:'grid.filter.datetime', type:'datetime', config:{pickerDefaults:{xtype:'datetimepicker', border:0}, dateFormat:undefined}, itemDefaults:{xtype:'menucheckitem', selectOnFocus:true, width:125, menu:{layout:'auto', plain:true}}, applyDateFormat:function(dateFormat) {
  return dateFormat || Ext.Date.defaultFormat;
}, createMenu:function(config) {
  var me = this, listeners = {scope:me, checkchange:me.onCheckChange}, menuItems = me.menuItems, fields, itemDefaults, pickerCfg, i, len, key, item, cfg, field;
  me.callParent(arguments);
  itemDefaults = me.getItemDefaults();
  fields = me.getFields();
  pickerCfg = Ext.apply({minDate:me.minDate, maxDate:me.maxDate, format:me.dateFormat, listeners:{scope:me, select:me.onMenuSelect}}, me.getPickerDefaults());
  me.fields = {};
  for (i = 0, len = menuItems.length; i < len; i++) {
    key = menuItems[i];
    if (key !== '-') {
      cfg = {menu:{xtype:'datetimemenu', pickerCfg:Ext.apply({itemId:key}, pickerCfg)}};
      if (itemDefaults) {
        Ext.merge(cfg, itemDefaults);
      }
      if (fields) {
        Ext.merge(cfg, fields[key]);
      }
      item = me.menu.add(cfg);
      field = me.fields[key] = item.down('datetimepicker');
      field.filter = me.filter[key];
      field.filterKey = key;
      item.on(listeners);
    } else {
      me.menu.add(key);
    }
  }
}, getPicker:function(item) {
  return this.fields[item];
}, onCheckChange:function(field, checked) {
  var filter = field.down('datetimepicker').filter, v;
  if (!checked && filter.getValue()) {
    v = {};
    v[filter.getOperator()] = null;
    this.setValue(v);
    var currentDateTime = new Date();
    field.down('#hours').setValue(0);
    field.down('#minutes').setValue(0);
    field.down('#seconds').setValue(0);
  }
}, onFilterRemove:function(operator) {
  var v = {};
  v[operator] = null;
  this.setValue(v);
  this.fields[operator].up('menuitem').setChecked(false, true);
}, onStateRestore:function(filter) {
  filter.setSerializer(this.getSerializer());
  filter.setConvert(this.convertDateTillSeconds);
}, getFilterConfig:function(config, key) {
  config = this.callParent([config, key]);
  config.serializer = this.getSerializer();
  config.convert = this.convertDateTillSeconds;
  return config;
}, convertDateTillSeconds:function(v) {
  var result = null;
  if (v) {
    result = v.getTime();
  }
  return result;
}, getSerializer:function() {
  var me = this;
  return function(data) {
    var value = data.value;
    if (value) {
      data.value = Ext.Date.format(value, me.getDateFormat());
    }
  };
}, onMenuSelect:function(picker, datetime) {
  var me = this, fields = me.fields, filters = me.filter, field = fields[picker.itemId], gt = fields.gt, lt = fields.lt, eq = fields.eq, v = {};
  field.up('menuitem').setChecked(true, true);
  if (field === eq) {
    lt.up('menuitem').setChecked(false, true);
    gt.up('menuitem').setChecked(false, true);
  } else {
    eq.up('menuitem').setChecked(false, true);
    if (field === gt && +lt.value < +datetime) {
      lt.up('menuitem').setChecked(false, true);
      if (filters.lt.getValue() != null) {
        v.lt = null;
      }
    } else if (field === lt && +gt.value > +datetime) {
      gt.up('menuitem').setChecked(false, true);
      if (filters.gt.getValue() != null) {
        v.gt = null;
      }
    }
  }
  v[field.filterKey] = datetime;
  me.setValue(v);
  picker.up('menu').hide();
}, getFields:function() {
  var fields = {lt:{text:this.beforeText ? this.beforeText : 'Before'}, gt:{text:this.afterText ? this.afterText : 'After'}, eq:{text:this.onText ? this.onText : 'On'}};
  return fields;
}});
Ext.define('interaction.view.tasklist.grids.stringWithCheckbox.StringWithCheckboxPlugin', {extend:'Ext.container.Container', alias:'widget.StringWithCheckboxPlugin', initComponent:function() {
  var me = this;
  Ext.apply(me, {layout:{type:'vbox', align:'stretch'}, border:2, margin:4, height:70, items:[{xtype:'textfield', enableKeyEvents:true, hideEmptyLabel:false, labelSeparator:'', labelWidth:25, margin:0, selectOnFocus:true, emptyText:'Enter Filter Text...', labelClsExtra:Ext.baseCSSPrefix + 'grid-filters-find', labelStyle:'padding: 8px 0px 0px 5px', itemId:'stringtext', listeners:{change:function(comp) {
    if (comp.getValue().length >= 0) {
      me.searchText = comp.getValue();
      me.up('[gridItemId\x3dgridColumn]').filter.setValue(comp.getValue());
      comp.up('bpcInteractionTasksGrid').reloadTasklistAfterFilterModification();
      me.fireEvent('select', me, comp.getValue());
    }
  }}}, {xtype:'checkbox', boxLabel:BpcCommon.Api.getTranslation('INTERACTION_REGEX_LABEL'), name:'reglex', inputValue:'1', itemId:'regexcheckbox', padding:'7px 0px 0px 5px', listeners:{change:function(comp) {
    if (comp.getValue() === true) {
      me.wildcardCheckbox = 'WILDCARD';
    } else {
      me.wildcardCheckbox = 'LIKE';
    }
    if (comp.up('bpcInteractionTasksGrid') && me.up('[gridItemId\x3dgridColumn]').filter) {
      me.up('[gridItemId\x3dgridColumn]').filter.filter.setOperator(me.wildcardCheckbox);
      var wildcardLocalStr = localStorage.getItem('interaction-wildcard-' + me.moduleId);
      if (wildcardLocalStr) {
        var locStorage;
        if (wildcardLocalStr.includes(me.columnName)) {
          var wildcardFilterArray = [];
          wildcardLocalStr.split(';').forEach(function(wcfilter) {
            if (wcfilter.includes(me.columnName)) {
              wcfilter = me.columnName + ':' + me.wildcardCheckbox;
            }
            wildcardFilterArray.push(wcfilter);
          });
          locStorage = wildcardFilterArray.join(';');
        } else {
          locStorage = wildcardLocalStr + ';' + me.columnName + ':' + me.wildcardCheckbox;
        }
      } else {
        locStorage = me.columnName + ':' + me.wildcardCheckbox;
      }
      localStorage.setItem('interaction-wildcard-' + me.moduleId, locStorage);
      comp.up('bpcInteractionTasksGrid').reloadTasklistAfterFilterModification();
      me.fireEvent('select', me, comp.getValue());
    }
  }}}]});
  me.callParent();
  var wildCardCheck = localStorage.getItem('interaction-wildcard-' + me.moduleId);
  if (wildCardCheck) {
    if (wildCardCheck.includes(me.columnName + ':WILDCARD')) {
      me.down('#regexcheckbox').setValue(true);
    }
  }
}, setValue:function(value) {
  var me = this;
  if (value) {
    me.down('#stringtext').setValue(value);
  } else {
    me.down('#stringtext').setValue('');
  }
}, getValue:function() {
  alert('get value called plugin');
  return 'returnText';
}, activateMenu:function() {
  this.inputItem[0].setValue(this.filter.getValue());
}});
Ext.define('interaction.view.tasklist.grids.stringWithCheckbox.StringWithCheckbox', {extend:'Ext.grid.filters.filter.SingleFilter', alias:'grid.filter.stringwithcheckbox', emptyText:'Enter Filter Text...', searchText:undefined, wildcardCheckbox:'LIKE', itemDefaults:{xtype:'StringWithCheckboxPlugin', enableKeyEvents:true, hideEmptyLabel:false, labelSeparator:'', labelWidth:29, margin:0, selectOnFocus:true}, menuDefaults:{bodyPadding:3, showSeparator:false}, createMenu:function() {
  var me = this, config;
  me.callParent();
  config = Ext.apply({}, me.getItemDefaults());
  config.columnName = me.dataIndex;
  config.moduleId = me.grid.moduleId;
  config.emptyText = config.emptyText || me.emptyText;
  me.inputItem = me.menu.add(config);
  me.inputItem.on({scope:me, keyup:me.onValueChange, el:{click:function(e) {
    e.stopPropagation();
  }}});
}, setValue:function(value) {
  var me = this;
  if (me.inputItem) {
    me.inputItem.setValue(value);
  }
  me.filter.setValue(value);
  if (value && me.active) {
    me.value = value;
    me.updateStoreFilter();
  } else {
    me.setActive(!!value);
  }
}, activateMenu:function() {
  this.inputItem.setValue(this.filter.getValue());
}, createFilter:function(config, key) {
  var me = this;
  if (me.filterFn) {
    return new Ext.util.Filter({filterFn:function(rec) {
      return Ext.callback(me.filterFn, me.scope, [rec, me.inputItem.getValue()]);
    }});
  } else {
    return me.callParent([config, key]);
  }
}});
Ext.define('interaction.view.tasklist.window.DelegateForm', {extend:'Ext.form.Panel', alias:'widget.interactionDelegateFormWindow', modal:true, padding:10, layout:{type:'vbox'}, defaults:{layout:'hbox', margin:10}, items:[], initComponent:function() {
  var $jscomp$this = this;
  this.height = document.body.clientHeight * 0.5;
  this.width = document.body.clientWidth * 0.3;
  this.callParent(arguments);
  interaction.Support.doRequest(this.delegateUrl, 'GET').then(function(response) {
    var panelItems = [];
    var isSubmitRequired = false;
    var responseXML = response.responseXML;
    if (responseXML) {
      var historyDom = Ext.DomQuery.select('Edit/Task/History/@user', responseXML);
      var historyNode = historyDom.length > 0 && historyDom[0].firstChild ? historyDom[0].firstChild.nodeValue : undefined;
      if (historyNode) {
        var historyArr = Ext.DomQuery.select('Edit/Task/History', responseXML);
        for (var i = 0; i < historyArr.length; i++) {
          var user = historyArr[i].getAttribute('user');
          var timestamp = historyArr[i].getAttribute('timestamp');
          var timeDate = (new Date(parseInt(timestamp))).toISOString();
          var j = i + 1;
          panelItems.push({xtype:'label', text:j + '. Delegation - ' + timeDate + ' - ' + user});
        }
      }
      var orgPersonDom = Ext.DomQuery.select('Edit/Entities/RuleSet/orgPerson/@name', responseXML);
      var orgPersonNode = orgPersonDom.length > 0 && orgPersonDom[0].firstChild ? orgPersonDom[0].firstChild.nodeValue : undefined;
      if (orgPersonNode) {
        isSubmitRequired = true;
        $jscomp$this.userCombo = Ext.create({xtype:'combo', fieldLabel:interaction.Support.getTranslation('delegate_user'), labelWidth:150, queryMode:'local', emptyText:'SELECT', displayField:'name', valueField:'value', editable:false, store:{fields:['name', 'value'], data:$jscomp$this.getItemsForDropdown(Ext.DomQuery.select('Entities/RuleSet/orgPerson', responseXML), 'orgPerson')}, listeners:{select:function(combo) {
          if (combo.getValue() !== '') {
            $jscomp$this.userButton.enable();
          }
        }}});
        $jscomp$this.userButton = Ext.create({xtype:'button', iconCls:interaction.Support.getBpcIconCls('check'), margin:'0 0 0 10', disabled:true, handler:function(b) {
          $jscomp$this.delegateButtonHandler({'path':$jscomp$this.userCombo.getValue(), 'delegateInfo':$jscomp$this.delegateInfo.getValue()});
        }});
        panelItems.push({items:[$jscomp$this.userCombo, $jscomp$this.userButton]});
      }
      var orgRoleDom = Ext.DomQuery.select('Edit/Entities/RuleSet/orgRole/@name', responseXML);
      var orgRoleNode = orgRoleDom.length > 0 && orgRoleDom[0].firstChild ? orgRoleDom[0].firstChild.nodeValue : undefined;
      if (orgRoleNode) {
        isSubmitRequired = true;
        $jscomp$this.roleCombo = Ext.create({xtype:'combo', fieldLabel:interaction.Support.getTranslation('delegate_role'), labelWidth:150, queryMode:'local', emptyText:'SELECT', displayField:'name', valueField:'value', editable:false, store:{fields:['name', 'value'], data:$jscomp$this.getItemsForDropdown(Ext.DomQuery.select('Entities/RuleSet/orgRole', responseXML), 'orgRole')}, listeners:{select:function(combo) {
          if (combo.getValue() !== '') {
            $jscomp$this.roleButton.enable();
          }
        }}});
        $jscomp$this.roleButton = Ext.create({xtype:'button', iconCls:interaction.Support.getBpcIconCls('check'), margin:'0 0 0 10', disabled:true, handler:function(b) {
          $jscomp$this.delegateButtonHandler({'path':$jscomp$this.roleCombo.getValue(), 'delegateInfo':$jscomp$this.delegateInfo.getValue()});
        }});
        panelItems.push({items:[$jscomp$this.roleCombo, $jscomp$this.roleButton]});
      }
      var orgUnitDom = Ext.DomQuery.select('Edit/Entities/RuleSet/orgUnit/@name', responseXML);
      var orgUnitNode = orgUnitDom.length > 0 && orgUnitDom[0].firstChild ? orgUnitDom[0].firstChild.nodeValue : undefined;
      if (orgUnitNode) {
        isSubmitRequired = true;
        $jscomp$this.unitCombo = Ext.create({xtype:'combo', fieldLabel:interaction.Support.getTranslation('delegate_unit'), labelWidth:150, queryMode:'local', emptyText:'SELECT', displayField:'name', valueField:'value', editable:false, store:{fields:['name', 'value'], data:$jscomp$this.getItemsForDropdown(Ext.DomQuery.select('Entities/RuleSet/orgUnit', responseXML), 'orgUnit')}, listeners:{select:function(combo, record, index) {
          if (combo.getValue() !== '') {
            $jscomp$this.unitButton.enable();
          }
        }}});
        $jscomp$this.unitButton = Ext.create({xtype:'button', iconCls:interaction.Support.getBpcIconCls('check'), margin:'0 0 0 10', disabled:true, handler:function(b) {
          $jscomp$this.delegateButtonHandler({'path':$jscomp$this.unitCombo.getValue(), 'delegateInfo':$jscomp$this.delegateInfo.getValue()});
        }});
        panelItems.push({items:[$jscomp$this.unitCombo, $jscomp$this.unitButton]});
      }
      if (isSubmitRequired) {
        $jscomp$this.delegateInfo = Ext.create({xtype:'textarea', fieldLabel:interaction.Support.getTranslation('info'), width:370, labelWidth:150});
        panelItems.push($jscomp$this.delegateInfo);
      }
      if (!orgRoleNode && !orgUnitNode && !orgPersonNode) {
        panelItems.push({xtype:'label', html:interaction.Support.getTranslation('NO_DELEGATION_MSG')});
      }
      panelItems.push({xtype:'button', text:interaction.Support.getTranslation('cancel_task'), margin:'0 0 0 230', handler:function() {
        $jscomp$this.closeWindow();
      }});
      $jscomp$this.add(panelItems);
    }
  }, function(error) {
    Ext.log('Ajax request for delegateTask:failure ', error);
  });
}, delegateButtonHandler:function(param) {
  var url = this.delegateSubmitUrl;
  Ext.getBody().mask('Loading...').dom.style.zIndex = '99999';
  Ext.Ajax.request({url:url, method:'POST', scope:this, jsonData:param, success:function() {
    this.closeWindow();
  }});
}, closeWindow:function() {
  var w = this.up('window');
  if (w) {
    w.close();
  }
}, getItemsForDropdown:function(arr) {
  var data = [];
  for (var i = 0; i < arr.length; i++) {
    var dropdownElement = {'name':arr[i].getAttribute('name'), 'value':arr[i].getAttribute('path')};
    data.push(dropdownElement);
  }
  return data;
}});
Ext.define('interaction.view.tasklist.window.Tooltip', {extend:'Ext.tip.ToolTip', alias:'window.tooltip', itemId:'tooltip', closable:true, closeAction:'hide', anchor:'left', anchorToTarget:true, mouseOffset:[50, 100], minWidth:150, minHeight:30});
Ext.define('interaction.view.tasklist.window.Window', {extend:'interaction.components.BaseWindow', alias:'widget.interactionTaskFormWindow', itemId:'autoload-win', constrain:false, constrainHeader:true, bodyStyle:'background-color: white', formName:undefined, taskName:undefined, moduleId:undefined, lang:undefined, tasksGrid:undefined, loadData:function(url) {
  interaction.Support.loadData(url).then(function(successResponse) {
  }, function(response) {
    if (response.status === 423) {
      Ext.Msg.alert(interaction.Support.getTranslation('warning'), interaction.Support.getTranslation('taskLocked'));
    }
  });
}, initComponent:function() {
  var $jscomp$this = this;
  this.height = document.body.clientHeight * 0.8;
  this.width = document.body.clientWidth * 0.8;
  this.unlockUrl = this.getUnlockUrl();
  this.form = this.formName;
  this.items = [{xtype:'interactionTaskFormPanel', header:false, title:this.taskName, lang:this.lang, activateHelp:localStorage.getItem('activateHelp-' + this.moduleId), tasksGrid:this.tasksGrid, moduleId:this.moduleId, formName:this.formName, baseUrl:this.baseUrl}];
  this.listeners = {close:function(window) {
    var panelName = 'i_' + window.formName.replaceAll('-', '') + '_' + 'MainPanel';
    interaction.Support.destroyMainPanel(panelName);
  }, beforeclose:function(win) {
    $jscomp$this.loadData($jscomp$this.unlockUrl);
  }};
  this.callParent(arguments);
}, getBaseParams:function() {
  return {instanceId:this.moduleId, lang:this.lang};
}, getBaseUrl:function() {
  return this.baseUrl;
}, getUnlockUrl:function() {
  var p = this.getBaseParams();
  p.id = this.formName;
  return this.getBaseUrl() + 'task/unlockAction' + '?' + Ext.Object.toQueryString(p);
}});
